<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Geo ServiceType
 * @subpackage Services
 */
class Geo extends AbstractSoapClientBase
{
    /**
     * Sets the HeaderLogin SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\HeaderLoginType $headerLogin
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderHeaderLogin(\StructType\HeaderLoginType $headerLogin, $nameSpace = 'http://www.webservices.nl/soap/', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'HeaderLogin', $headerLogin, $mustUnderstand, $actor);
    }
    /**
     * Sets the HeaderAuthenticate SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\HeaderAuthenticateType $headerAuthenticate
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderHeaderAuthenticate(\StructType\HeaderAuthenticateType $headerAuthenticate, $nameSpace = 'http://www.webservices.nl/soap/', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'HeaderAuthenticate', $headerAuthenticate, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named
     * geoLocationNeighborhoodCoordinatesRD
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates in the RD system of the neighborhood, given the neighborhood code
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationNeighborhoodCoordinatesRDRequestType $parameters
     * @return \StructType\GeoLocationNeighborhoodCoordinatesRDResponseType|bool
     */
    public function geoLocationNeighborhoodCoordinatesRD(\StructType\GeoLocationNeighborhoodCoordinatesRDRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationNeighborhoodCoordinatesRD($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationPostcodeCoordinatesRD
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given postcode in the RD system.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationPostcodeCoordinatesRDRequestType $parameters
     * @return \StructType\GeoLocationPostcodeCoordinatesRDResponseType|bool
     */
    public function geoLocationPostcodeCoordinatesRD(\StructType\GeoLocationPostcodeCoordinatesRDRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationPostcodeCoordinatesRD($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationNeighborhoodCoordinatesLatLon
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates in degrees of latitude/longitude of the neighborhood, given the neighborhood code
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationNeighborhoodCoordinatesLatLonRequestType $parameters
     * @return \StructType\GeoLocationNeighborhoodCoordinatesLatLonResponseType|bool
     */
    public function geoLocationNeighborhoodCoordinatesLatLon(\StructType\GeoLocationNeighborhoodCoordinatesLatLonRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationNeighborhoodCoordinatesLatLon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationPostcodeCoordinatesLatLon
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given postcode in degrees of latitude/longitude.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationPostcodeCoordinatesLatLonRequestType $parameters
     * @return \StructType\GeoLocationPostcodeCoordinatesLatLonResponseType|bool
     */
    public function geoLocationPostcodeCoordinatesLatLon(\StructType\GeoLocationPostcodeCoordinatesLatLonRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationPostcodeCoordinatesLatLon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationAddressCoordinatesLatLon
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given address in degrees of latitude/longitude. Address may be specified by postcode + house number or by city + street + house number.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationAddressCoordinatesLatLonRequestType $parameters
     * @return \StructType\GeoLocationAddressCoordinatesLatLonResponseType|bool
     */
    public function geoLocationAddressCoordinatesLatLon(\StructType\GeoLocationAddressCoordinatesLatLonRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationAddressCoordinatesLatLon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationAddressCoordinatesRD
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given address in the RD system. Address may be specified by postcode + house number or by city + street + house number.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationAddressCoordinatesRDRequestType $parameters
     * @return \StructType\GeoLocationAddressCoordinatesRDResponseType|bool
     */
    public function geoLocationAddressCoordinatesRD(\StructType\GeoLocationAddressCoordinatesRDRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationAddressCoordinatesRD($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationLatLonToPostcode
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the postcode of the address closest to the specified latitude/longitude coordinate in the Netherlands.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationLatLonToPostcodeRequestType $parameters
     * @return \StructType\GeoLocationLatLonToPostcodeResponseType|bool
     */
    public function geoLocationLatLonToPostcode(\StructType\GeoLocationLatLonToPostcodeRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationLatLonToPostcode($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationLatLonToAddressV2
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the address closest to the specified latitude/longitude coordinate in the Netherlands. The returned x, y, latitude and logitude values are the coordinates of the retrieved address. Distance is the distance between these
     * coordinates and the input coordinate in meters
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationLatLonToAddressV2RequestType $parameters
     * @return \StructType\GeoLocationLatLonToAddressV2ResponseType|bool
     */
    public function geoLocationLatLonToAddressV2(\StructType\GeoLocationLatLonToAddressV2RequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationLatLonToAddressV2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationRDToPostcode
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the postcode of the address closest to the specified Rijksdriehoeksmeting coordinate in the Netherlands.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationRDToPostcodeRequestType $parameters
     * @return \StructType\GeoLocationRDToPostcodeResponseType|bool
     */
    public function geoLocationRDToPostcode(\StructType\GeoLocationRDToPostcodeRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationRDToPostcode($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationRDToAddressV2
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the address closest to the specified Rijksdriehoeksmeting coordinate in the Netherlands. The returned x, y, latitude and logitude values are the coordinates of the retrieved address. Distance is the distance between these
     * coordinates and the input coordinate in meters
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationRDToAddressV2RequestType $parameters
     * @return \StructType\GeoLocationRDToAddressV2ResponseType|bool
     */
    public function geoLocationRDToAddressV2(\StructType\GeoLocationRDToAddressV2RequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationRDToAddressV2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationInternationalPostcodeCoordinatesLatLon
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given postcode in degrees of latitude/longitude. Most countries are supported in the function. Accuracy of the result may vary between countries.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationInternationalPostcodeCoordinatesLatLonRequestType $parameters
     * @return \StructType\GeoLocationInternationalPostcodeCoordinatesLatLonResponseType|bool
     */
    public function geoLocationInternationalPostcodeCoordinatesLatLon(\StructType\GeoLocationInternationalPostcodeCoordinatesLatLonRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationInternationalPostcodeCoordinatesLatLon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationInternationalAddressCoordinatesLatLon
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given address in degrees of latitude/longitude. Most countries are supported in the function. Accuracy of the result may vary between countries. Since the street and city have to contain the complete
     * name and since this method acts with international data, we recommend to use <geoLocationInternationalPostcodeCoordinatesLatLon> if you know the postcode, since working with postcodes is less error prone.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationInternationalAddressCoordinatesLatLonRequestType $parameters
     * @return \StructType\GeoLocationInternationalAddressCoordinatesLatLonResponseType|bool
     */
    public function geoLocationInternationalAddressCoordinatesLatLon(\StructType\GeoLocationInternationalAddressCoordinatesLatLonRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationInternationalAddressCoordinatesLatLon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationInternationalAddressCoordinatesLatLonV2
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the coordinates of the given address in degrees of latitude/longitude. Most countries are supported in the function. Accuracy of the result may vary between countries.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationInternationalAddressCoordinatesLatLonV2RequestType $parameters
     * @return \StructType\GeoLocationInternationalAddressCoordinatesLatLonV2ResponseType|bool
     */
    public function geoLocationInternationalAddressCoordinatesLatLonV2(\StructType\GeoLocationInternationalAddressCoordinatesLatLonV2RequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationInternationalAddressCoordinatesLatLonV2($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationInternationalLatLonToAddress
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the address closest to the specified latitude/longitude coordinate. The returned latitude and logitude values make up the coordinate of the retrieved address. Distance is the distance between this coordinate and the input
     * coordinate in meters
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationInternationalLatLonToAddressRequestType $parameters
     * @return \StructType\GeoLocationInternationalLatLonToAddressResponseType|bool
     */
    public function geoLocationInternationalLatLonToAddress(\StructType\GeoLocationInternationalLatLonToAddressRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationInternationalLatLonToAddress($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationNeighborhoodDistance
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the estimated distance in meters (in a direct line) between the two neighborhoods, given the neighborhood codes
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationNeighborhoodDistanceRequestType $parameters
     * @return \StructType\GeoLocationNeighborhoodDistanceResponseType|bool
     */
    public function geoLocationNeighborhoodDistance(\StructType\GeoLocationNeighborhoodDistanceRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationNeighborhoodDistance($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationPostcodeDistance
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the estimated distance in meters (in a direct line) between the two postcodes.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationPostcodeDistanceRequestType $parameters
     * @return \StructType\GeoLocationPostcodeDistanceResponseType|bool
     */
    public function geoLocationPostcodeDistance(\StructType\GeoLocationPostcodeDistanceRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationPostcodeDistance($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationHaversineDistance
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the distance in meters (in a direct line) between two latitude/longitude coordinates
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationHaversineDistanceRequestType $parameters
     * @return \StructType\GeoLocationHaversineDistanceResponseType|bool
     */
    public function geoLocationHaversineDistance(\StructType\GeoLocationHaversineDistanceRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationHaversineDistance($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationDistanceSortedNeighborhoodCodes
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the neighborhood codes list sorted in order of increasing distance from a given neighborhood.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationDistanceSortedNeighborhoodCodesRequestType $parameters
     * @return \StructType\GeoLocationDistanceSortedNeighborhoodCodesResponseType|bool
     */
    public function geoLocationDistanceSortedNeighborhoodCodes(\StructType\GeoLocationDistanceSortedNeighborhoodCodesRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationDistanceSortedNeighborhoodCodes($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationDistanceSortedNeighborhoodCodesRadius
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns the neighborhood codes list sorted in order of increasing distance from a given neighborhood, within a given radius (in meters).
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationDistanceSortedNeighborhoodCodesRadiusRequestType $parameters
     * @return \StructType\GeoLocationDistanceSortedNeighborhoodCodesRadiusResponseType|bool
     */
    public function geoLocationDistanceSortedNeighborhoodCodesRadius(\StructType\GeoLocationDistanceSortedNeighborhoodCodesRadiusRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationDistanceSortedNeighborhoodCodesRadius($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named
     * geoLocationDistanceSortedPostcodesRadius
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns a list of postcodes sorted in order of increasing distance from a given postcode, within a given radius (in meters). If the radius is larger than 1500 meters, the result will be based on neighborhood codes
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationDistanceSortedPostcodesRadiusRequestType $parameters
     * @return \StructType\GeoLocationDistanceSortedPostcodesRadiusResponseType|bool
     */
    public function geoLocationDistanceSortedPostcodesRadius(\StructType\GeoLocationDistanceSortedPostcodesRadiusRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationDistanceSortedPostcodesRadius($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationDistanceSortedPostcodes
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Returns a given postcode list sorted in order of increasingdistance from a given postcode.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationDistanceSortedPostcodesRequestType $parameters
     * @return \StructType\GeoLocationDistanceSortedPostcodesResponseType|bool
     */
    public function geoLocationDistanceSortedPostcodes(\StructType\GeoLocationDistanceSortedPostcodesRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationDistanceSortedPostcodes($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationLatLonToRD
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Convert a latitude/longitude coordinate to a RD ('Rijksdriehoeksmeting') coordinate.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationLatLonToRDRequestType $parameters
     * @return \StructType\GeoLocationLatLonToRDResponseType|bool
     */
    public function geoLocationLatLonToRD(\StructType\GeoLocationLatLonToRDRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationLatLonToRD($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named geoLocationRDToLatLon
     * Meta information extracted from the WSDL
     * - SOAPHeaderNames: HeaderLogin, HeaderAuthenticate
     * - SOAPHeaderNamespaces: http://www.webservices.nl/soap/, http://www.webservices.nl/soap/
     * - SOAPHeaderTypes: \StructType\HeaderLoginType, \StructType\HeaderAuthenticateType
     * - SOAPHeaders: required, required
     * - documentation: Convert a RD ('Rijksdriehoeksmeting') coordinate to a latitude/longitude coordinate.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GeoLocationRDToLatLonRequestType $parameters
     * @return \StructType\GeoLocationRDToLatLonResponseType|bool
     */
    public function geoLocationRDToLatLon(\StructType\GeoLocationRDToLatLonRequestType $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->geoLocationRDToLatLon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\GeoLocationAddressCoordinatesLatLonResponseType|\StructType\GeoLocationAddressCoordinatesRDResponseType|\StructType\GeoLocationDistanceSortedNeighborhoodCodesRadiusResponseType|\StructType\GeoLocationDistanceSortedNeighborhoodCodesResponseType|\StructType\GeoLocationDistanceSortedPostcodesRadiusResponseType|\StructType\GeoLocationDistanceSortedPostcodesResponseType|\StructType\GeoLocationHaversineDistanceResponseType|\StructType\GeoLocationInternationalAddressCoordinatesLatLonResponseType|\StructType\GeoLocationInternationalAddressCoordinatesLatLonV2ResponseType|\StructType\GeoLocationInternationalLatLonToAddressResponseType|\StructType\GeoLocationInternationalPostcodeCoordinatesLatLonResponseType|\StructType\GeoLocationLatLonToAddressV2ResponseType|\StructType\GeoLocationLatLonToPostcodeResponseType|\StructType\GeoLocationLatLonToRDResponseType|\StructType\GeoLocationNeighborhoodCoordinatesLatLonResponseType|\StructType\GeoLocationNeighborhoodCoordinatesRDResponseType|\StructType\GeoLocationNeighborhoodDistanceResponseType|\StructType\GeoLocationPostcodeCoordinatesLatLonResponseType|\StructType\GeoLocationPostcodeCoordinatesRDResponseType|\StructType\GeoLocationPostcodeDistanceResponseType|\StructType\GeoLocationRDToAddressV2ResponseType|\StructType\GeoLocationRDToLatLonResponseType|\StructType\GeoLocationRDToPostcodeResponseType
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
