<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessBankAccount StructType
 * @subpackage Structs
 */
class BelgianBusinessBankAccount extends AbstractStructBase
{
    /**
     * The iban
     * @var string
     */
    public $iban;
    /**
     * The bic
     * @var string
     */
    public $bic;
    /**
     * The iban_valid
     * @var bool
     */
    public $iban_valid;
    /**
     * The start_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDate
     */
    public $start_date;
    /**
     * Constructor method for BelgianBusinessBankAccount
     * @uses BelgianBusinessBankAccount::setIban()
     * @uses BelgianBusinessBankAccount::setBic()
     * @uses BelgianBusinessBankAccount::setIban_valid()
     * @uses BelgianBusinessBankAccount::setStart_date()
     * @param string $iban
     * @param string $bic
     * @param bool $iban_valid
     * @param \StructType\BelgianBusinessDate $start_date
     */
    public function __construct($iban = null, $bic = null, $iban_valid = null, \StructType\BelgianBusinessDate $start_date = null)
    {
        $this
            ->setIban($iban)
            ->setBic($bic)
            ->setIban_valid($iban_valid)
            ->setStart_date($start_date);
    }
    /**
     * Get iban value
     * @return string|null
     */
    public function getIban()
    {
        return $this->iban;
    }
    /**
     * Set iban value
     * @param string $iban
     * @return \StructType\BelgianBusinessBankAccount
     */
    public function setIban($iban = null)
    {
        // validation for constraint: string
        if (!is_null($iban) && !is_string($iban)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iban, true), gettype($iban)), __LINE__);
        }
        $this->iban = $iban;
        return $this;
    }
    /**
     * Get bic value
     * @return string|null
     */
    public function getBic()
    {
        return $this->bic;
    }
    /**
     * Set bic value
     * @param string $bic
     * @return \StructType\BelgianBusinessBankAccount
     */
    public function setBic($bic = null)
    {
        // validation for constraint: string
        if (!is_null($bic) && !is_string($bic)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bic, true), gettype($bic)), __LINE__);
        }
        $this->bic = $bic;
        return $this;
    }
    /**
     * Get iban_valid value
     * @return bool|null
     */
    public function getIban_valid()
    {
        return $this->iban_valid;
    }
    /**
     * Set iban_valid value
     * @param bool $iban_valid
     * @return \StructType\BelgianBusinessBankAccount
     */
    public function setIban_valid($iban_valid = null)
    {
        // validation for constraint: boolean
        if (!is_null($iban_valid) && !is_bool($iban_valid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($iban_valid, true), gettype($iban_valid)), __LINE__);
        }
        $this->iban_valid = $iban_valid;
        return $this;
    }
    /**
     * Get start_date value
     * @return \StructType\BelgianBusinessDate|null
     */
    public function getStart_date()
    {
        return $this->start_date;
    }
    /**
     * Set start_date value
     * @param \StructType\BelgianBusinessDate $start_date
     * @return \StructType\BelgianBusinessBankAccount
     */
    public function setStart_date(\StructType\BelgianBusinessDate $start_date = null)
    {
        $this->start_date = $start_date;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BelgianBusinessBankAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
