<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessCompany StructType
 * @subpackage Structs
 */
class BelgianBusinessCompany extends AbstractStructBase
{
    /**
     * The vat_number
     * @var string
     */
    public $vat_number;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The phone_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phone_number;
    /**
     * The website
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $website;
    /**
     * The start_date
     * @var \StructType\BelgianBusinessDate
     */
    public $start_date;
    /**
     * The establishment_units
     * @var int
     */
    public $establishment_units;
    /**
     * The type
     * @var \StructType\BelgianBusinessDatedItem
     */
    public $type;
    /**
     * The activities
     * @var \ArrayType\BelgianBusinessDatedItemArray
     */
    public $activities;
    /**
     * The addresses
     * @var \ArrayType\BelgianBusinessAddressArray
     */
    public $addresses;
    /**
     * The juridical_form
     * @var \StructType\BelgianBusinessDatedItem
     */
    public $juridical_form;
    /**
     * The juridical_situation
     * @var \StructType\BelgianBusinessDatedItem
     */
    public $juridical_situation;
    /**
     * The legal_representatives_count
     * @var string
     */
    public $legal_representatives_count;
    /**
     * The legal_representative_companies_count
     * @var string
     */
    public $legal_representative_companies_count;
    /**
     * Constructor method for BelgianBusinessCompany
     * @uses BelgianBusinessCompany::setVat_number()
     * @uses BelgianBusinessCompany::setName()
     * @uses BelgianBusinessCompany::setPhone_number()
     * @uses BelgianBusinessCompany::setWebsite()
     * @uses BelgianBusinessCompany::setStart_date()
     * @uses BelgianBusinessCompany::setEstablishment_units()
     * @uses BelgianBusinessCompany::setType()
     * @uses BelgianBusinessCompany::setActivities()
     * @uses BelgianBusinessCompany::setAddresses()
     * @uses BelgianBusinessCompany::setJuridical_form()
     * @uses BelgianBusinessCompany::setJuridical_situation()
     * @uses BelgianBusinessCompany::setLegal_representatives_count()
     * @uses BelgianBusinessCompany::setLegal_representative_companies_count()
     * @param string $vat_number
     * @param string $name
     * @param string $phone_number
     * @param string $website
     * @param \StructType\BelgianBusinessDate $start_date
     * @param int $establishment_units
     * @param \StructType\BelgianBusinessDatedItem $type
     * @param \ArrayType\BelgianBusinessDatedItemArray $activities
     * @param \ArrayType\BelgianBusinessAddressArray $addresses
     * @param \StructType\BelgianBusinessDatedItem $juridical_form
     * @param \StructType\BelgianBusinessDatedItem $juridical_situation
     * @param string $legal_representatives_count
     * @param string $legal_representative_companies_count
     */
    public function __construct($vat_number = null, $name = null, $phone_number = null, $website = null, \StructType\BelgianBusinessDate $start_date = null, $establishment_units = null, \StructType\BelgianBusinessDatedItem $type = null, \ArrayType\BelgianBusinessDatedItemArray $activities = null, \ArrayType\BelgianBusinessAddressArray $addresses = null, \StructType\BelgianBusinessDatedItem $juridical_form = null, \StructType\BelgianBusinessDatedItem $juridical_situation = null, $legal_representatives_count = null, $legal_representative_companies_count = null)
    {
        $this
            ->setVat_number($vat_number)
            ->setName($name)
            ->setPhone_number($phone_number)
            ->setWebsite($website)
            ->setStart_date($start_date)
            ->setEstablishment_units($establishment_units)
            ->setType($type)
            ->setActivities($activities)
            ->setAddresses($addresses)
            ->setJuridical_form($juridical_form)
            ->setJuridical_situation($juridical_situation)
            ->setLegal_representatives_count($legal_representatives_count)
            ->setLegal_representative_companies_count($legal_representative_companies_count);
    }
    /**
     * Get vat_number value
     * @return string|null
     */
    public function getVat_number()
    {
        return $this->vat_number;
    }
    /**
     * Set vat_number value
     * @param string $vat_number
     * @return \StructType\BelgianBusinessCompany
     */
    public function setVat_number($vat_number = null)
    {
        // validation for constraint: string
        if (!is_null($vat_number) && !is_string($vat_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vat_number, true), gettype($vat_number)), __LINE__);
        }
        $this->vat_number = $vat_number;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\BelgianBusinessCompany
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get phone_number value
     * @return string|null
     */
    public function getPhone_number()
    {
        return $this->phone_number;
    }
    /**
     * Set phone_number value
     * @param string $phone_number
     * @return \StructType\BelgianBusinessCompany
     */
    public function setPhone_number($phone_number = null)
    {
        // validation for constraint: string
        if (!is_null($phone_number) && !is_string($phone_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phone_number, true), gettype($phone_number)), __LINE__);
        }
        $this->phone_number = $phone_number;
        return $this;
    }
    /**
     * Get website value
     * @return string|null
     */
    public function getWebsite()
    {
        return $this->website;
    }
    /**
     * Set website value
     * @param string $website
     * @return \StructType\BelgianBusinessCompany
     */
    public function setWebsite($website = null)
    {
        // validation for constraint: string
        if (!is_null($website) && !is_string($website)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($website, true), gettype($website)), __LINE__);
        }
        $this->website = $website;
        return $this;
    }
    /**
     * Get start_date value
     * @return \StructType\BelgianBusinessDate|null
     */
    public function getStart_date()
    {
        return $this->start_date;
    }
    /**
     * Set start_date value
     * @param \StructType\BelgianBusinessDate $start_date
     * @return \StructType\BelgianBusinessCompany
     */
    public function setStart_date(\StructType\BelgianBusinessDate $start_date = null)
    {
        $this->start_date = $start_date;
        return $this;
    }
    /**
     * Get establishment_units value
     * @return int|null
     */
    public function getEstablishment_units()
    {
        return $this->establishment_units;
    }
    /**
     * Set establishment_units value
     * @param int $establishment_units
     * @return \StructType\BelgianBusinessCompany
     */
    public function setEstablishment_units($establishment_units = null)
    {
        // validation for constraint: int
        if (!is_null($establishment_units) && !(is_int($establishment_units) || ctype_digit($establishment_units))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($establishment_units, true), gettype($establishment_units)), __LINE__);
        }
        $this->establishment_units = $establishment_units;
        return $this;
    }
    /**
     * Get type value
     * @return \StructType\BelgianBusinessDatedItem|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param \StructType\BelgianBusinessDatedItem $type
     * @return \StructType\BelgianBusinessCompany
     */
    public function setType(\StructType\BelgianBusinessDatedItem $type = null)
    {
        $this->type = $type;
        return $this;
    }
    /**
     * Get activities value
     * @return \ArrayType\BelgianBusinessDatedItemArray|null
     */
    public function getActivities()
    {
        return $this->activities;
    }
    /**
     * Set activities value
     * @param \ArrayType\BelgianBusinessDatedItemArray $activities
     * @return \StructType\BelgianBusinessCompany
     */
    public function setActivities(\ArrayType\BelgianBusinessDatedItemArray $activities = null)
    {
        $this->activities = $activities;
        return $this;
    }
    /**
     * Get addresses value
     * @return \ArrayType\BelgianBusinessAddressArray|null
     */
    public function getAddresses()
    {
        return $this->addresses;
    }
    /**
     * Set addresses value
     * @param \ArrayType\BelgianBusinessAddressArray $addresses
     * @return \StructType\BelgianBusinessCompany
     */
    public function setAddresses(\ArrayType\BelgianBusinessAddressArray $addresses = null)
    {
        $this->addresses = $addresses;
        return $this;
    }
    /**
     * Get juridical_form value
     * @return \StructType\BelgianBusinessDatedItem|null
     */
    public function getJuridical_form()
    {
        return $this->juridical_form;
    }
    /**
     * Set juridical_form value
     * @param \StructType\BelgianBusinessDatedItem $juridical_form
     * @return \StructType\BelgianBusinessCompany
     */
    public function setJuridical_form(\StructType\BelgianBusinessDatedItem $juridical_form = null)
    {
        $this->juridical_form = $juridical_form;
        return $this;
    }
    /**
     * Get juridical_situation value
     * @return \StructType\BelgianBusinessDatedItem|null
     */
    public function getJuridical_situation()
    {
        return $this->juridical_situation;
    }
    /**
     * Set juridical_situation value
     * @param \StructType\BelgianBusinessDatedItem $juridical_situation
     * @return \StructType\BelgianBusinessCompany
     */
    public function setJuridical_situation(\StructType\BelgianBusinessDatedItem $juridical_situation = null)
    {
        $this->juridical_situation = $juridical_situation;
        return $this;
    }
    /**
     * Get legal_representatives_count value
     * @return string|null
     */
    public function getLegal_representatives_count()
    {
        return $this->legal_representatives_count;
    }
    /**
     * Set legal_representatives_count value
     * @param string $legal_representatives_count
     * @return \StructType\BelgianBusinessCompany
     */
    public function setLegal_representatives_count($legal_representatives_count = null)
    {
        // validation for constraint: string
        if (!is_null($legal_representatives_count) && !is_string($legal_representatives_count)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_representatives_count, true), gettype($legal_representatives_count)), __LINE__);
        }
        $this->legal_representatives_count = $legal_representatives_count;
        return $this;
    }
    /**
     * Get legal_representative_companies_count value
     * @return string|null
     */
    public function getLegal_representative_companies_count()
    {
        return $this->legal_representative_companies_count;
    }
    /**
     * Set legal_representative_companies_count value
     * @param string $legal_representative_companies_count
     * @return \StructType\BelgianBusinessCompany
     */
    public function setLegal_representative_companies_count($legal_representative_companies_count = null)
    {
        // validation for constraint: string
        if (!is_null($legal_representative_companies_count) && !is_string($legal_representative_companies_count)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_representative_companies_count, true), gettype($legal_representative_companies_count)), __LINE__);
        }
        $this->legal_representative_companies_count = $legal_representative_companies_count;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BelgianBusinessCompany
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
