<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessLegalRepresentative StructType
 * @subpackage Structs
 */
class BelgianBusinessLegalRepresentative extends AbstractStructBase
{
    /**
     * The company_vat_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $company_vat_number;
    /**
     * The role
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDatedItem
     */
    public $role;
    /**
     * The first_name
     * @var string
     */
    public $first_name;
    /**
     * The last_name
     * @var string
     */
    public $last_name;
    /**
     * Constructor method for BelgianBusinessLegalRepresentative
     * @uses BelgianBusinessLegalRepresentative::setCompany_vat_number()
     * @uses BelgianBusinessLegalRepresentative::setRole()
     * @uses BelgianBusinessLegalRepresentative::setFirst_name()
     * @uses BelgianBusinessLegalRepresentative::setLast_name()
     * @param string $company_vat_number
     * @param \StructType\BelgianBusinessDatedItem $role
     * @param string $first_name
     * @param string $last_name
     */
    public function __construct($company_vat_number = null, \StructType\BelgianBusinessDatedItem $role = null, $first_name = null, $last_name = null)
    {
        $this
            ->setCompany_vat_number($company_vat_number)
            ->setRole($role)
            ->setFirst_name($first_name)
            ->setLast_name($last_name);
    }
    /**
     * Get company_vat_number value
     * @return string|null
     */
    public function getCompany_vat_number()
    {
        return $this->company_vat_number;
    }
    /**
     * Set company_vat_number value
     * @param string $company_vat_number
     * @return \StructType\BelgianBusinessLegalRepresentative
     */
    public function setCompany_vat_number($company_vat_number = null)
    {
        // validation for constraint: string
        if (!is_null($company_vat_number) && !is_string($company_vat_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_vat_number, true), gettype($company_vat_number)), __LINE__);
        }
        $this->company_vat_number = $company_vat_number;
        return $this;
    }
    /**
     * Get role value
     * @return \StructType\BelgianBusinessDatedItem|null
     */
    public function getRole()
    {
        return $this->role;
    }
    /**
     * Set role value
     * @param \StructType\BelgianBusinessDatedItem $role
     * @return \StructType\BelgianBusinessLegalRepresentative
     */
    public function setRole(\StructType\BelgianBusinessDatedItem $role = null)
    {
        $this->role = $role;
        return $this;
    }
    /**
     * Get first_name value
     * @return string|null
     */
    public function getFirst_name()
    {
        return $this->first_name;
    }
    /**
     * Set first_name value
     * @param string $first_name
     * @return \StructType\BelgianBusinessLegalRepresentative
     */
    public function setFirst_name($first_name = null)
    {
        // validation for constraint: string
        if (!is_null($first_name) && !is_string($first_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($first_name, true), gettype($first_name)), __LINE__);
        }
        $this->first_name = $first_name;
        return $this;
    }
    /**
     * Get last_name value
     * @return string|null
     */
    public function getLast_name()
    {
        return $this->last_name;
    }
    /**
     * Set last_name value
     * @param string $last_name
     * @return \StructType\BelgianBusinessLegalRepresentative
     */
    public function setLast_name($last_name = null)
    {
        // validation for constraint: string
        if (!is_null($last_name) && !is_string($last_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($last_name, true), gettype($last_name)), __LINE__);
        }
        $this->last_name = $last_name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BelgianBusinessLegalRepresentative
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
