<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessLegalRepresentativeCompany StructType
 * @subpackage Structs
 */
class BelgianBusinessLegalRepresentativeCompany extends AbstractStructBase
{
    /**
     * The vat_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $vat_number;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The role
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDatedItem
     */
    public $role;
    /**
     * Constructor method for BelgianBusinessLegalRepresentativeCompany
     * @uses BelgianBusinessLegalRepresentativeCompany::setVat_number()
     * @uses BelgianBusinessLegalRepresentativeCompany::setName()
     * @uses BelgianBusinessLegalRepresentativeCompany::setRole()
     * @param string $vat_number
     * @param string $name
     * @param \StructType\BelgianBusinessDatedItem $role
     */
    public function __construct($vat_number = null, $name = null, \StructType\BelgianBusinessDatedItem $role = null)
    {
        $this
            ->setVat_number($vat_number)
            ->setName($name)
            ->setRole($role);
    }
    /**
     * Get vat_number value
     * @return string|null
     */
    public function getVat_number()
    {
        return $this->vat_number;
    }
    /**
     * Set vat_number value
     * @param string $vat_number
     * @return \StructType\BelgianBusinessLegalRepresentativeCompany
     */
    public function setVat_number($vat_number = null)
    {
        // validation for constraint: string
        if (!is_null($vat_number) && !is_string($vat_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vat_number, true), gettype($vat_number)), __LINE__);
        }
        $this->vat_number = $vat_number;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\BelgianBusinessLegalRepresentativeCompany
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get role value
     * @return \StructType\BelgianBusinessDatedItem|null
     */
    public function getRole()
    {
        return $this->role;
    }
    /**
     * Set role value
     * @param \StructType\BelgianBusinessDatedItem $role
     * @return \StructType\BelgianBusinessLegalRepresentativeCompany
     */
    public function setRole(\StructType\BelgianBusinessDatedItem $role = null)
    {
        $this->role = $role;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BelgianBusinessLegalRepresentativeCompany
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
