<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BerichtObjectDocumentResultaat StructType
 * @subpackage Structs
 */
class BerichtObjectDocumentResultaat extends AbstractStructBase
{
    /**
     * The overzicht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DocumentOverzicht
     */
    public $overzicht;
    /**
     * The eigendomsbericht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BerichtObjectDocument
     */
    public $eigendomsbericht;
    /**
     * Constructor method for BerichtObjectDocumentResultaat
     * @uses BerichtObjectDocumentResultaat::setOverzicht()
     * @uses BerichtObjectDocumentResultaat::setEigendomsbericht()
     * @param \StructType\DocumentOverzicht $overzicht
     * @param \StructType\BerichtObjectDocument $eigendomsbericht
     */
    public function __construct(\StructType\DocumentOverzicht $overzicht = null, \StructType\BerichtObjectDocument $eigendomsbericht = null)
    {
        $this
            ->setOverzicht($overzicht)
            ->setEigendomsbericht($eigendomsbericht);
    }
    /**
     * Get overzicht value
     * @return \StructType\DocumentOverzicht|null
     */
    public function getOverzicht()
    {
        return $this->overzicht;
    }
    /**
     * Set overzicht value
     * @param \StructType\DocumentOverzicht $overzicht
     * @return \StructType\BerichtObjectDocumentResultaat
     */
    public function setOverzicht(\StructType\DocumentOverzicht $overzicht = null)
    {
        $this->overzicht = $overzicht;
        return $this;
    }
    /**
     * Get eigendomsbericht value
     * @return \StructType\BerichtObjectDocument|null
     */
    public function getEigendomsbericht()
    {
        return $this->eigendomsbericht;
    }
    /**
     * Set eigendomsbericht value
     * @param \StructType\BerichtObjectDocument $eigendomsbericht
     * @return \StructType\BerichtObjectDocumentResultaat
     */
    public function setEigendomsbericht(\StructType\BerichtObjectDocument $eigendomsbericht = null)
    {
        $this->eigendomsbericht = $eigendomsbericht;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BerichtObjectDocumentResultaat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
