<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarV2 StructType
 * @subpackage Structs
 */
class CarV2 extends AbstractStructBase
{
    /**
     * The car_data
     * @var \StructType\Car
     */
    public $car_data;
    /**
     * The types
     * @var \ArrayType\CarTypeArray
     */
    public $types;
    /**
     * Constructor method for CarV2
     * @uses CarV2::setCar_data()
     * @uses CarV2::setTypes()
     * @param \StructType\Car $car_data
     * @param \ArrayType\CarTypeArray $types
     */
    public function __construct(\StructType\Car $car_data = null, \ArrayType\CarTypeArray $types = null)
    {
        $this
            ->setCar_data($car_data)
            ->setTypes($types);
    }
    /**
     * Get car_data value
     * @return \StructType\Car|null
     */
    public function getCar_data()
    {
        return $this->car_data;
    }
    /**
     * Set car_data value
     * @param \StructType\Car $car_data
     * @return \StructType\CarV2
     */
    public function setCar_data(\StructType\Car $car_data = null)
    {
        $this->car_data = $car_data;
        return $this;
    }
    /**
     * Get types value
     * @return \ArrayType\CarTypeArray|null
     */
    public function getTypes()
    {
        return $this->types;
    }
    /**
     * Set types value
     * @param \ArrayType\CarTypeArray $types
     * @return \StructType\CarV2
     */
    public function setTypes(\ArrayType\CarTypeArray $types = null)
    {
        $this->types = $types;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CarV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
