<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarVWEVersionPrice StructType
 * @subpackage Structs
 */
class CarVWEVersionPrice extends AbstractStructBase
{
    /**
     * The brand_atl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $brand_atl;
    /**
     * The model_atl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $model_atl;
    /**
     * The short_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $short_type;
    /**
     * The fuel_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fuel_type;
    /**
     * The cylinder_capacity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $cylinder_capacity;
    /**
     * The seats
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $seats;
    /**
     * The power
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $power;
    /**
     * The energy_label
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $energy_label;
    /**
     * The emission_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $emission_code;
    /**
     * The doors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $doors;
    /**
     * The gear
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $gear;
    /**
     * The top_speed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $top_speed;
    /**
     * The folder_weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $folder_weight;
    /**
     * The train_weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $train_weight;
    /**
     * The layout
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $layout;
    /**
     * The design
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $design;
    /**
     * The acceleration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $acceleration;
    /**
     * The sportivity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $sportivity;
    /**
     * The version
     * @var \StructType\CarVWEVersionPriceReference
     */
    public $version;
    /**
     * The prices
     * @var \StructType\CarVWEPrices
     */
    public $prices;
    /**
     * Constructor method for CarVWEVersionPrice
     * @uses CarVWEVersionPrice::setBrand_atl()
     * @uses CarVWEVersionPrice::setModel_atl()
     * @uses CarVWEVersionPrice::setShort_type()
     * @uses CarVWEVersionPrice::setFuel_type()
     * @uses CarVWEVersionPrice::setCylinder_capacity()
     * @uses CarVWEVersionPrice::setSeats()
     * @uses CarVWEVersionPrice::setPower()
     * @uses CarVWEVersionPrice::setEnergy_label()
     * @uses CarVWEVersionPrice::setEmission_code()
     * @uses CarVWEVersionPrice::setDoors()
     * @uses CarVWEVersionPrice::setGear()
     * @uses CarVWEVersionPrice::setTop_speed()
     * @uses CarVWEVersionPrice::setFolder_weight()
     * @uses CarVWEVersionPrice::setTrain_weight()
     * @uses CarVWEVersionPrice::setLayout()
     * @uses CarVWEVersionPrice::setDesign()
     * @uses CarVWEVersionPrice::setAcceleration()
     * @uses CarVWEVersionPrice::setSportivity()
     * @uses CarVWEVersionPrice::setVersion()
     * @uses CarVWEVersionPrice::setPrices()
     * @param string $brand_atl
     * @param string $model_atl
     * @param string $short_type
     * @param string $fuel_type
     * @param int $cylinder_capacity
     * @param int $seats
     * @param int $power
     * @param string $energy_label
     * @param string $emission_code
     * @param int $doors
     * @param string $gear
     * @param int $top_speed
     * @param int $folder_weight
     * @param int $train_weight
     * @param string $layout
     * @param string $design
     * @param float $acceleration
     * @param float $sportivity
     * @param \StructType\CarVWEVersionPriceReference $version
     * @param \StructType\CarVWEPrices $prices
     */
    public function __construct($brand_atl = null, $model_atl = null, $short_type = null, $fuel_type = null, $cylinder_capacity = null, $seats = null, $power = null, $energy_label = null, $emission_code = null, $doors = null, $gear = null, $top_speed = null, $folder_weight = null, $train_weight = null, $layout = null, $design = null, $acceleration = null, $sportivity = null, \StructType\CarVWEVersionPriceReference $version = null, \StructType\CarVWEPrices $prices = null)
    {
        $this
            ->setBrand_atl($brand_atl)
            ->setModel_atl($model_atl)
            ->setShort_type($short_type)
            ->setFuel_type($fuel_type)
            ->setCylinder_capacity($cylinder_capacity)
            ->setSeats($seats)
            ->setPower($power)
            ->setEnergy_label($energy_label)
            ->setEmission_code($emission_code)
            ->setDoors($doors)
            ->setGear($gear)
            ->setTop_speed($top_speed)
            ->setFolder_weight($folder_weight)
            ->setTrain_weight($train_weight)
            ->setLayout($layout)
            ->setDesign($design)
            ->setAcceleration($acceleration)
            ->setSportivity($sportivity)
            ->setVersion($version)
            ->setPrices($prices);
    }
    /**
     * Get brand_atl value
     * @return string|null
     */
    public function getBrand_atl()
    {
        return $this->brand_atl;
    }
    /**
     * Set brand_atl value
     * @param string $brand_atl
     * @return \StructType\CarVWEVersionPrice
     */
    public function setBrand_atl($brand_atl = null)
    {
        // validation for constraint: string
        if (!is_null($brand_atl) && !is_string($brand_atl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($brand_atl, true), gettype($brand_atl)), __LINE__);
        }
        $this->brand_atl = $brand_atl;
        return $this;
    }
    /**
     * Get model_atl value
     * @return string|null
     */
    public function getModel_atl()
    {
        return $this->model_atl;
    }
    /**
     * Set model_atl value
     * @param string $model_atl
     * @return \StructType\CarVWEVersionPrice
     */
    public function setModel_atl($model_atl = null)
    {
        // validation for constraint: string
        if (!is_null($model_atl) && !is_string($model_atl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($model_atl, true), gettype($model_atl)), __LINE__);
        }
        $this->model_atl = $model_atl;
        return $this;
    }
    /**
     * Get short_type value
     * @return string|null
     */
    public function getShort_type()
    {
        return $this->short_type;
    }
    /**
     * Set short_type value
     * @param string $short_type
     * @return \StructType\CarVWEVersionPrice
     */
    public function setShort_type($short_type = null)
    {
        // validation for constraint: string
        if (!is_null($short_type) && !is_string($short_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($short_type, true), gettype($short_type)), __LINE__);
        }
        $this->short_type = $short_type;
        return $this;
    }
    /**
     * Get fuel_type value
     * @return string|null
     */
    public function getFuel_type()
    {
        return $this->fuel_type;
    }
    /**
     * Set fuel_type value
     * @param string $fuel_type
     * @return \StructType\CarVWEVersionPrice
     */
    public function setFuel_type($fuel_type = null)
    {
        // validation for constraint: string
        if (!is_null($fuel_type) && !is_string($fuel_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fuel_type, true), gettype($fuel_type)), __LINE__);
        }
        $this->fuel_type = $fuel_type;
        return $this;
    }
    /**
     * Get cylinder_capacity value
     * @return int|null
     */
    public function getCylinder_capacity()
    {
        return $this->cylinder_capacity;
    }
    /**
     * Set cylinder_capacity value
     * @param int $cylinder_capacity
     * @return \StructType\CarVWEVersionPrice
     */
    public function setCylinder_capacity($cylinder_capacity = null)
    {
        // validation for constraint: int
        if (!is_null($cylinder_capacity) && !(is_int($cylinder_capacity) || ctype_digit($cylinder_capacity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cylinder_capacity, true), gettype($cylinder_capacity)), __LINE__);
        }
        $this->cylinder_capacity = $cylinder_capacity;
        return $this;
    }
    /**
     * Get seats value
     * @return int|null
     */
    public function getSeats()
    {
        return $this->seats;
    }
    /**
     * Set seats value
     * @param int $seats
     * @return \StructType\CarVWEVersionPrice
     */
    public function setSeats($seats = null)
    {
        // validation for constraint: int
        if (!is_null($seats) && !(is_int($seats) || ctype_digit($seats))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($seats, true), gettype($seats)), __LINE__);
        }
        $this->seats = $seats;
        return $this;
    }
    /**
     * Get power value
     * @return int|null
     */
    public function getPower()
    {
        return $this->power;
    }
    /**
     * Set power value
     * @param int $power
     * @return \StructType\CarVWEVersionPrice
     */
    public function setPower($power = null)
    {
        // validation for constraint: int
        if (!is_null($power) && !(is_int($power) || ctype_digit($power))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($power, true), gettype($power)), __LINE__);
        }
        $this->power = $power;
        return $this;
    }
    /**
     * Get energy_label value
     * @return string|null
     */
    public function getEnergy_label()
    {
        return $this->energy_label;
    }
    /**
     * Set energy_label value
     * @param string $energy_label
     * @return \StructType\CarVWEVersionPrice
     */
    public function setEnergy_label($energy_label = null)
    {
        // validation for constraint: string
        if (!is_null($energy_label) && !is_string($energy_label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($energy_label, true), gettype($energy_label)), __LINE__);
        }
        $this->energy_label = $energy_label;
        return $this;
    }
    /**
     * Get emission_code value
     * @return string|null
     */
    public function getEmission_code()
    {
        return $this->emission_code;
    }
    /**
     * Set emission_code value
     * @param string $emission_code
     * @return \StructType\CarVWEVersionPrice
     */
    public function setEmission_code($emission_code = null)
    {
        // validation for constraint: string
        if (!is_null($emission_code) && !is_string($emission_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emission_code, true), gettype($emission_code)), __LINE__);
        }
        $this->emission_code = $emission_code;
        return $this;
    }
    /**
     * Get doors value
     * @return int|null
     */
    public function getDoors()
    {
        return $this->doors;
    }
    /**
     * Set doors value
     * @param int $doors
     * @return \StructType\CarVWEVersionPrice
     */
    public function setDoors($doors = null)
    {
        // validation for constraint: int
        if (!is_null($doors) && !(is_int($doors) || ctype_digit($doors))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($doors, true), gettype($doors)), __LINE__);
        }
        $this->doors = $doors;
        return $this;
    }
    /**
     * Get gear value
     * @return string|null
     */
    public function getGear()
    {
        return $this->gear;
    }
    /**
     * Set gear value
     * @param string $gear
     * @return \StructType\CarVWEVersionPrice
     */
    public function setGear($gear = null)
    {
        // validation for constraint: string
        if (!is_null($gear) && !is_string($gear)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gear, true), gettype($gear)), __LINE__);
        }
        $this->gear = $gear;
        return $this;
    }
    /**
     * Get top_speed value
     * @return int|null
     */
    public function getTop_speed()
    {
        return $this->top_speed;
    }
    /**
     * Set top_speed value
     * @param int $top_speed
     * @return \StructType\CarVWEVersionPrice
     */
    public function setTop_speed($top_speed = null)
    {
        // validation for constraint: int
        if (!is_null($top_speed) && !(is_int($top_speed) || ctype_digit($top_speed))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($top_speed, true), gettype($top_speed)), __LINE__);
        }
        $this->top_speed = $top_speed;
        return $this;
    }
    /**
     * Get folder_weight value
     * @return int|null
     */
    public function getFolder_weight()
    {
        return $this->folder_weight;
    }
    /**
     * Set folder_weight value
     * @param int $folder_weight
     * @return \StructType\CarVWEVersionPrice
     */
    public function setFolder_weight($folder_weight = null)
    {
        // validation for constraint: int
        if (!is_null($folder_weight) && !(is_int($folder_weight) || ctype_digit($folder_weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($folder_weight, true), gettype($folder_weight)), __LINE__);
        }
        $this->folder_weight = $folder_weight;
        return $this;
    }
    /**
     * Get train_weight value
     * @return int|null
     */
    public function getTrain_weight()
    {
        return $this->train_weight;
    }
    /**
     * Set train_weight value
     * @param int $train_weight
     * @return \StructType\CarVWEVersionPrice
     */
    public function setTrain_weight($train_weight = null)
    {
        // validation for constraint: int
        if (!is_null($train_weight) && !(is_int($train_weight) || ctype_digit($train_weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($train_weight, true), gettype($train_weight)), __LINE__);
        }
        $this->train_weight = $train_weight;
        return $this;
    }
    /**
     * Get layout value
     * @return string|null
     */
    public function getLayout()
    {
        return $this->layout;
    }
    /**
     * Set layout value
     * @param string $layout
     * @return \StructType\CarVWEVersionPrice
     */
    public function setLayout($layout = null)
    {
        // validation for constraint: string
        if (!is_null($layout) && !is_string($layout)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($layout, true), gettype($layout)), __LINE__);
        }
        $this->layout = $layout;
        return $this;
    }
    /**
     * Get design value
     * @return string|null
     */
    public function getDesign()
    {
        return $this->design;
    }
    /**
     * Set design value
     * @param string $design
     * @return \StructType\CarVWEVersionPrice
     */
    public function setDesign($design = null)
    {
        // validation for constraint: string
        if (!is_null($design) && !is_string($design)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($design, true), gettype($design)), __LINE__);
        }
        $this->design = $design;
        return $this;
    }
    /**
     * Get acceleration value
     * @return float|null
     */
    public function getAcceleration()
    {
        return $this->acceleration;
    }
    /**
     * Set acceleration value
     * @param float $acceleration
     * @return \StructType\CarVWEVersionPrice
     */
    public function setAcceleration($acceleration = null)
    {
        // validation for constraint: float
        if (!is_null($acceleration) && !(is_float($acceleration) || is_numeric($acceleration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($acceleration, true), gettype($acceleration)), __LINE__);
        }
        $this->acceleration = $acceleration;
        return $this;
    }
    /**
     * Get sportivity value
     * @return float|null
     */
    public function getSportivity()
    {
        return $this->sportivity;
    }
    /**
     * Set sportivity value
     * @param float $sportivity
     * @return \StructType\CarVWEVersionPrice
     */
    public function setSportivity($sportivity = null)
    {
        // validation for constraint: float
        if (!is_null($sportivity) && !(is_float($sportivity) || is_numeric($sportivity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sportivity, true), gettype($sportivity)), __LINE__);
        }
        $this->sportivity = $sportivity;
        return $this;
    }
    /**
     * Get version value
     * @return \StructType\CarVWEVersionPriceReference|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param \StructType\CarVWEVersionPriceReference $version
     * @return \StructType\CarVWEVersionPrice
     */
    public function setVersion(\StructType\CarVWEVersionPriceReference $version = null)
    {
        $this->version = $version;
        return $this;
    }
    /**
     * Get prices value
     * @return \StructType\CarVWEPrices|null
     */
    public function getPrices()
    {
        return $this->prices;
    }
    /**
     * Set prices value
     * @param \StructType\CarVWEPrices $prices
     * @return \StructType\CarVWEVersionPrice
     */
    public function setPrices(\StructType\CarVWEPrices $prices = null)
    {
        $this->prices = $prices;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CarVWEVersionPrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
