<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyActivityClassificationV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyActivityClassificationV2 extends AbstractStructBase
{
    /**
     * The activities
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeCompanyActivityV2Array
     */
    public $activities;
    /**
     * The classification
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $classification;
    /**
     * Constructor method for CreditsafeCompanyActivityClassificationV2
     * @uses CreditsafeCompanyActivityClassificationV2::setActivities()
     * @uses CreditsafeCompanyActivityClassificationV2::setClassification()
     * @param \ArrayType\CreditsafeCompanyActivityV2Array $activities
     * @param string $classification
     */
    public function __construct(\ArrayType\CreditsafeCompanyActivityV2Array $activities = null, $classification = null)
    {
        $this
            ->setActivities($activities)
            ->setClassification($classification);
    }
    /**
     * Get activities value
     * @return \ArrayType\CreditsafeCompanyActivityV2Array|null
     */
    public function getActivities()
    {
        return $this->activities;
    }
    /**
     * Set activities value
     * @param \ArrayType\CreditsafeCompanyActivityV2Array $activities
     * @return \StructType\CreditsafeCompanyActivityClassificationV2
     */
    public function setActivities(\ArrayType\CreditsafeCompanyActivityV2Array $activities = null)
    {
        $this->activities = $activities;
        return $this;
    }
    /**
     * Get classification value
     * @return string|null
     */
    public function getClassification()
    {
        return $this->classification;
    }
    /**
     * Set classification value
     * @param string $classification
     * @return \StructType\CreditsafeCompanyActivityClassificationV2
     */
    public function setClassification($classification = null)
    {
        // validation for constraint: string
        if (!is_null($classification) && !is_string($classification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($classification, true), gettype($classification)), __LINE__);
        }
        $this->classification = $classification;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyActivityClassificationV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
