<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyFinancialStatementV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyFinancialStatementV2 extends AbstractStructBase
{
    /**
     * The balance_sheet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyBalanceSheetV2
     */
    public $balance_sheet;
    /**
     * The consolidated_accounts
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $consolidated_accounts;
    /**
     * The currency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $currency;
    /**
     * The number_of_weeks
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $number_of_weeks;
    /**
     * The other_financials
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyOtherFinancialsV2
     */
    public $other_financials;
    /**
     * The profit_and_loss
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public $profit_and_loss;
    /**
     * The ratios
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyRatiosV2
     */
    public $ratios;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The year_end_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $year_end_date;
    /**
     * Constructor method for CreditsafeCompanyFinancialStatementV2
     * @uses CreditsafeCompanyFinancialStatementV2::setBalance_sheet()
     * @uses CreditsafeCompanyFinancialStatementV2::setConsolidated_accounts()
     * @uses CreditsafeCompanyFinancialStatementV2::setCurrency()
     * @uses CreditsafeCompanyFinancialStatementV2::setNumber_of_weeks()
     * @uses CreditsafeCompanyFinancialStatementV2::setOther_financials()
     * @uses CreditsafeCompanyFinancialStatementV2::setProfit_and_loss()
     * @uses CreditsafeCompanyFinancialStatementV2::setRatios()
     * @uses CreditsafeCompanyFinancialStatementV2::setType()
     * @uses CreditsafeCompanyFinancialStatementV2::setYear_end_date()
     * @param \StructType\CreditsafeCompanyBalanceSheetV2 $balance_sheet
     * @param bool $consolidated_accounts
     * @param string $currency
     * @param int $number_of_weeks
     * @param \StructType\CreditsafeCompanyOtherFinancialsV2 $other_financials
     * @param \StructType\CreditsafeCompanyProfitAndLossV2 $profit_and_loss
     * @param \StructType\CreditsafeCompanyRatiosV2 $ratios
     * @param string $type
     * @param string $year_end_date
     */
    public function __construct(\StructType\CreditsafeCompanyBalanceSheetV2 $balance_sheet = null, $consolidated_accounts = null, $currency = null, $number_of_weeks = null, \StructType\CreditsafeCompanyOtherFinancialsV2 $other_financials = null, \StructType\CreditsafeCompanyProfitAndLossV2 $profit_and_loss = null, \StructType\CreditsafeCompanyRatiosV2 $ratios = null, $type = null, $year_end_date = null)
    {
        $this
            ->setBalance_sheet($balance_sheet)
            ->setConsolidated_accounts($consolidated_accounts)
            ->setCurrency($currency)
            ->setNumber_of_weeks($number_of_weeks)
            ->setOther_financials($other_financials)
            ->setProfit_and_loss($profit_and_loss)
            ->setRatios($ratios)
            ->setType($type)
            ->setYear_end_date($year_end_date);
    }
    /**
     * Get balance_sheet value
     * @return \StructType\CreditsafeCompanyBalanceSheetV2|null
     */
    public function getBalance_sheet()
    {
        return $this->balance_sheet;
    }
    /**
     * Set balance_sheet value
     * @param \StructType\CreditsafeCompanyBalanceSheetV2 $balance_sheet
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setBalance_sheet(\StructType\CreditsafeCompanyBalanceSheetV2 $balance_sheet = null)
    {
        $this->balance_sheet = $balance_sheet;
        return $this;
    }
    /**
     * Get consolidated_accounts value
     * @return bool|null
     */
    public function getConsolidated_accounts()
    {
        return $this->consolidated_accounts;
    }
    /**
     * Set consolidated_accounts value
     * @param bool $consolidated_accounts
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setConsolidated_accounts($consolidated_accounts = null)
    {
        // validation for constraint: boolean
        if (!is_null($consolidated_accounts) && !is_bool($consolidated_accounts)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($consolidated_accounts, true), gettype($consolidated_accounts)), __LINE__);
        }
        $this->consolidated_accounts = $consolidated_accounts;
        return $this;
    }
    /**
     * Get currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->currency;
    }
    /**
     * Set currency value
     * @param string $currency
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        $this->currency = $currency;
        return $this;
    }
    /**
     * Get number_of_weeks value
     * @return int|null
     */
    public function getNumber_of_weeks()
    {
        return $this->number_of_weeks;
    }
    /**
     * Set number_of_weeks value
     * @param int $number_of_weeks
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setNumber_of_weeks($number_of_weeks = null)
    {
        // validation for constraint: int
        if (!is_null($number_of_weeks) && !(is_int($number_of_weeks) || ctype_digit($number_of_weeks))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number_of_weeks, true), gettype($number_of_weeks)), __LINE__);
        }
        $this->number_of_weeks = $number_of_weeks;
        return $this;
    }
    /**
     * Get other_financials value
     * @return \StructType\CreditsafeCompanyOtherFinancialsV2|null
     */
    public function getOther_financials()
    {
        return $this->other_financials;
    }
    /**
     * Set other_financials value
     * @param \StructType\CreditsafeCompanyOtherFinancialsV2 $other_financials
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setOther_financials(\StructType\CreditsafeCompanyOtherFinancialsV2 $other_financials = null)
    {
        $this->other_financials = $other_financials;
        return $this;
    }
    /**
     * Get profit_and_loss value
     * @return \StructType\CreditsafeCompanyProfitAndLossV2|null
     */
    public function getProfit_and_loss()
    {
        return $this->profit_and_loss;
    }
    /**
     * Set profit_and_loss value
     * @param \StructType\CreditsafeCompanyProfitAndLossV2 $profit_and_loss
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setProfit_and_loss(\StructType\CreditsafeCompanyProfitAndLossV2 $profit_and_loss = null)
    {
        $this->profit_and_loss = $profit_and_loss;
        return $this;
    }
    /**
     * Get ratios value
     * @return \StructType\CreditsafeCompanyRatiosV2|null
     */
    public function getRatios()
    {
        return $this->ratios;
    }
    /**
     * Set ratios value
     * @param \StructType\CreditsafeCompanyRatiosV2 $ratios
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setRatios(\StructType\CreditsafeCompanyRatiosV2 $ratios = null)
    {
        $this->ratios = $ratios;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get year_end_date value
     * @return string|null
     */
    public function getYear_end_date()
    {
        return $this->year_end_date;
    }
    /**
     * Set year_end_date value
     * @param string $year_end_date
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public function setYear_end_date($year_end_date = null)
    {
        // validation for constraint: string
        if (!is_null($year_end_date) && !is_string($year_end_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($year_end_date, true), gettype($year_end_date)), __LINE__);
        }
        $this->year_end_date = $year_end_date;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyFinancialStatementV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
