<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyNegativeInformationDEV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyNegativeInformationDEV2 extends AbstractStructBase
{
    /**
     * The bankruptcy
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyNegativeInformationDEBankruptcyV2
     */
    public $bankruptcy;
    /**
     * The insolvency_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyNegativeInformationDEInsolvencyInformationV2
     */
    public $insolvency_information;
    /**
     * The director_events
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeCompanyNegativeInformationDEDirectorEventV2Array
     */
    public $director_events;
    /**
     * Constructor method for CreditsafeCompanyNegativeInformationDEV2
     * @uses CreditsafeCompanyNegativeInformationDEV2::setBankruptcy()
     * @uses CreditsafeCompanyNegativeInformationDEV2::setInsolvency_information()
     * @uses CreditsafeCompanyNegativeInformationDEV2::setDirector_events()
     * @param \StructType\CreditsafeCompanyNegativeInformationDEBankruptcyV2 $bankruptcy
     * @param \StructType\CreditsafeCompanyNegativeInformationDEInsolvencyInformationV2 $insolvency_information
     * @param \ArrayType\CreditsafeCompanyNegativeInformationDEDirectorEventV2Array $director_events
     */
    public function __construct(\StructType\CreditsafeCompanyNegativeInformationDEBankruptcyV2 $bankruptcy = null, \StructType\CreditsafeCompanyNegativeInformationDEInsolvencyInformationV2 $insolvency_information = null, \ArrayType\CreditsafeCompanyNegativeInformationDEDirectorEventV2Array $director_events = null)
    {
        $this
            ->setBankruptcy($bankruptcy)
            ->setInsolvency_information($insolvency_information)
            ->setDirector_events($director_events);
    }
    /**
     * Get bankruptcy value
     * @return \StructType\CreditsafeCompanyNegativeInformationDEBankruptcyV2|null
     */
    public function getBankruptcy()
    {
        return $this->bankruptcy;
    }
    /**
     * Set bankruptcy value
     * @param \StructType\CreditsafeCompanyNegativeInformationDEBankruptcyV2 $bankruptcy
     * @return \StructType\CreditsafeCompanyNegativeInformationDEV2
     */
    public function setBankruptcy(\StructType\CreditsafeCompanyNegativeInformationDEBankruptcyV2 $bankruptcy = null)
    {
        $this->bankruptcy = $bankruptcy;
        return $this;
    }
    /**
     * Get insolvency_information value
     * @return \StructType\CreditsafeCompanyNegativeInformationDEInsolvencyInformationV2|null
     */
    public function getInsolvency_information()
    {
        return $this->insolvency_information;
    }
    /**
     * Set insolvency_information value
     * @param \StructType\CreditsafeCompanyNegativeInformationDEInsolvencyInformationV2 $insolvency_information
     * @return \StructType\CreditsafeCompanyNegativeInformationDEV2
     */
    public function setInsolvency_information(\StructType\CreditsafeCompanyNegativeInformationDEInsolvencyInformationV2 $insolvency_information = null)
    {
        $this->insolvency_information = $insolvency_information;
        return $this;
    }
    /**
     * Get director_events value
     * @return \ArrayType\CreditsafeCompanyNegativeInformationDEDirectorEventV2Array|null
     */
    public function getDirector_events()
    {
        return $this->director_events;
    }
    /**
     * Set director_events value
     * @param \ArrayType\CreditsafeCompanyNegativeInformationDEDirectorEventV2Array $director_events
     * @return \StructType\CreditsafeCompanyNegativeInformationDEV2
     */
    public function setDirector_events(\ArrayType\CreditsafeCompanyNegativeInformationDEDirectorEventV2Array $director_events = null)
    {
        $this->director_events = $director_events;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyNegativeInformationDEV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
