<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyProfitAndLossV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyProfitAndLossV2 extends AbstractStructBase
{
    /**
     * The depreciation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $depreciation;
    /**
     * The dividends
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $dividends;
    /**
     * The financial_expenses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $financial_expenses;
    /**
     * The financial_income
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $financial_income;
    /**
     * The operating_costs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $operating_costs;
    /**
     * The operating_profit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $operating_profit;
    /**
     * The other_appropriations
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $other_appropriations;
    /**
     * The pension_costs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $pension_costs;
    /**
     * The profit_after_tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $profit_after_tax;
    /**
     * The profit_before_tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $profit_before_tax;
    /**
     * The retained_profit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $retained_profit;
    /**
     * The revenue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $revenue;
    /**
     * The tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $tax;
    /**
     * The wages_and_salaries
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $wages_and_salaries;
    /**
     * Constructor method for CreditsafeCompanyProfitAndLossV2
     * @uses CreditsafeCompanyProfitAndLossV2::setDepreciation()
     * @uses CreditsafeCompanyProfitAndLossV2::setDividends()
     * @uses CreditsafeCompanyProfitAndLossV2::setFinancial_expenses()
     * @uses CreditsafeCompanyProfitAndLossV2::setFinancial_income()
     * @uses CreditsafeCompanyProfitAndLossV2::setOperating_costs()
     * @uses CreditsafeCompanyProfitAndLossV2::setOperating_profit()
     * @uses CreditsafeCompanyProfitAndLossV2::setOther_appropriations()
     * @uses CreditsafeCompanyProfitAndLossV2::setPension_costs()
     * @uses CreditsafeCompanyProfitAndLossV2::setProfit_after_tax()
     * @uses CreditsafeCompanyProfitAndLossV2::setProfit_before_tax()
     * @uses CreditsafeCompanyProfitAndLossV2::setRetained_profit()
     * @uses CreditsafeCompanyProfitAndLossV2::setRevenue()
     * @uses CreditsafeCompanyProfitAndLossV2::setTax()
     * @uses CreditsafeCompanyProfitAndLossV2::setWages_and_salaries()
     * @param int $depreciation
     * @param int $dividends
     * @param int $financial_expenses
     * @param int $financial_income
     * @param int $operating_costs
     * @param int $operating_profit
     * @param int $other_appropriations
     * @param int $pension_costs
     * @param int $profit_after_tax
     * @param int $profit_before_tax
     * @param int $retained_profit
     * @param int $revenue
     * @param int $tax
     * @param int $wages_and_salaries
     */
    public function __construct($depreciation = null, $dividends = null, $financial_expenses = null, $financial_income = null, $operating_costs = null, $operating_profit = null, $other_appropriations = null, $pension_costs = null, $profit_after_tax = null, $profit_before_tax = null, $retained_profit = null, $revenue = null, $tax = null, $wages_and_salaries = null)
    {
        $this
            ->setDepreciation($depreciation)
            ->setDividends($dividends)
            ->setFinancial_expenses($financial_expenses)
            ->setFinancial_income($financial_income)
            ->setOperating_costs($operating_costs)
            ->setOperating_profit($operating_profit)
            ->setOther_appropriations($other_appropriations)
            ->setPension_costs($pension_costs)
            ->setProfit_after_tax($profit_after_tax)
            ->setProfit_before_tax($profit_before_tax)
            ->setRetained_profit($retained_profit)
            ->setRevenue($revenue)
            ->setTax($tax)
            ->setWages_and_salaries($wages_and_salaries);
    }
    /**
     * Get depreciation value
     * @return int|null
     */
    public function getDepreciation()
    {
        return $this->depreciation;
    }
    /**
     * Set depreciation value
     * @param int $depreciation
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setDepreciation($depreciation = null)
    {
        // validation for constraint: int
        if (!is_null($depreciation) && !(is_int($depreciation) || ctype_digit($depreciation))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($depreciation, true), gettype($depreciation)), __LINE__);
        }
        $this->depreciation = $depreciation;
        return $this;
    }
    /**
     * Get dividends value
     * @return int|null
     */
    public function getDividends()
    {
        return $this->dividends;
    }
    /**
     * Set dividends value
     * @param int $dividends
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setDividends($dividends = null)
    {
        // validation for constraint: int
        if (!is_null($dividends) && !(is_int($dividends) || ctype_digit($dividends))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dividends, true), gettype($dividends)), __LINE__);
        }
        $this->dividends = $dividends;
        return $this;
    }
    /**
     * Get financial_expenses value
     * @return int|null
     */
    public function getFinancial_expenses()
    {
        return $this->financial_expenses;
    }
    /**
     * Set financial_expenses value
     * @param int $financial_expenses
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setFinancial_expenses($financial_expenses = null)
    {
        // validation for constraint: int
        if (!is_null($financial_expenses) && !(is_int($financial_expenses) || ctype_digit($financial_expenses))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($financial_expenses, true), gettype($financial_expenses)), __LINE__);
        }
        $this->financial_expenses = $financial_expenses;
        return $this;
    }
    /**
     * Get financial_income value
     * @return int|null
     */
    public function getFinancial_income()
    {
        return $this->financial_income;
    }
    /**
     * Set financial_income value
     * @param int $financial_income
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setFinancial_income($financial_income = null)
    {
        // validation for constraint: int
        if (!is_null($financial_income) && !(is_int($financial_income) || ctype_digit($financial_income))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($financial_income, true), gettype($financial_income)), __LINE__);
        }
        $this->financial_income = $financial_income;
        return $this;
    }
    /**
     * Get operating_costs value
     * @return int|null
     */
    public function getOperating_costs()
    {
        return $this->operating_costs;
    }
    /**
     * Set operating_costs value
     * @param int $operating_costs
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setOperating_costs($operating_costs = null)
    {
        // validation for constraint: int
        if (!is_null($operating_costs) && !(is_int($operating_costs) || ctype_digit($operating_costs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($operating_costs, true), gettype($operating_costs)), __LINE__);
        }
        $this->operating_costs = $operating_costs;
        return $this;
    }
    /**
     * Get operating_profit value
     * @return int|null
     */
    public function getOperating_profit()
    {
        return $this->operating_profit;
    }
    /**
     * Set operating_profit value
     * @param int $operating_profit
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setOperating_profit($operating_profit = null)
    {
        // validation for constraint: int
        if (!is_null($operating_profit) && !(is_int($operating_profit) || ctype_digit($operating_profit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($operating_profit, true), gettype($operating_profit)), __LINE__);
        }
        $this->operating_profit = $operating_profit;
        return $this;
    }
    /**
     * Get other_appropriations value
     * @return int|null
     */
    public function getOther_appropriations()
    {
        return $this->other_appropriations;
    }
    /**
     * Set other_appropriations value
     * @param int $other_appropriations
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setOther_appropriations($other_appropriations = null)
    {
        // validation for constraint: int
        if (!is_null($other_appropriations) && !(is_int($other_appropriations) || ctype_digit($other_appropriations))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($other_appropriations, true), gettype($other_appropriations)), __LINE__);
        }
        $this->other_appropriations = $other_appropriations;
        return $this;
    }
    /**
     * Get pension_costs value
     * @return int|null
     */
    public function getPension_costs()
    {
        return $this->pension_costs;
    }
    /**
     * Set pension_costs value
     * @param int $pension_costs
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setPension_costs($pension_costs = null)
    {
        // validation for constraint: int
        if (!is_null($pension_costs) && !(is_int($pension_costs) || ctype_digit($pension_costs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pension_costs, true), gettype($pension_costs)), __LINE__);
        }
        $this->pension_costs = $pension_costs;
        return $this;
    }
    /**
     * Get profit_after_tax value
     * @return int|null
     */
    public function getProfit_after_tax()
    {
        return $this->profit_after_tax;
    }
    /**
     * Set profit_after_tax value
     * @param int $profit_after_tax
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setProfit_after_tax($profit_after_tax = null)
    {
        // validation for constraint: int
        if (!is_null($profit_after_tax) && !(is_int($profit_after_tax) || ctype_digit($profit_after_tax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($profit_after_tax, true), gettype($profit_after_tax)), __LINE__);
        }
        $this->profit_after_tax = $profit_after_tax;
        return $this;
    }
    /**
     * Get profit_before_tax value
     * @return int|null
     */
    public function getProfit_before_tax()
    {
        return $this->profit_before_tax;
    }
    /**
     * Set profit_before_tax value
     * @param int $profit_before_tax
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setProfit_before_tax($profit_before_tax = null)
    {
        // validation for constraint: int
        if (!is_null($profit_before_tax) && !(is_int($profit_before_tax) || ctype_digit($profit_before_tax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($profit_before_tax, true), gettype($profit_before_tax)), __LINE__);
        }
        $this->profit_before_tax = $profit_before_tax;
        return $this;
    }
    /**
     * Get retained_profit value
     * @return int|null
     */
    public function getRetained_profit()
    {
        return $this->retained_profit;
    }
    /**
     * Set retained_profit value
     * @param int $retained_profit
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setRetained_profit($retained_profit = null)
    {
        // validation for constraint: int
        if (!is_null($retained_profit) && !(is_int($retained_profit) || ctype_digit($retained_profit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($retained_profit, true), gettype($retained_profit)), __LINE__);
        }
        $this->retained_profit = $retained_profit;
        return $this;
    }
    /**
     * Get revenue value
     * @return int|null
     */
    public function getRevenue()
    {
        return $this->revenue;
    }
    /**
     * Set revenue value
     * @param int $revenue
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setRevenue($revenue = null)
    {
        // validation for constraint: int
        if (!is_null($revenue) && !(is_int($revenue) || ctype_digit($revenue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($revenue, true), gettype($revenue)), __LINE__);
        }
        $this->revenue = $revenue;
        return $this;
    }
    /**
     * Get tax value
     * @return int|null
     */
    public function getTax()
    {
        return $this->tax;
    }
    /**
     * Set tax value
     * @param int $tax
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setTax($tax = null)
    {
        // validation for constraint: int
        if (!is_null($tax) && !(is_int($tax) || ctype_digit($tax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tax, true), gettype($tax)), __LINE__);
        }
        $this->tax = $tax;
        return $this;
    }
    /**
     * Get wages_and_salaries value
     * @return int|null
     */
    public function getWages_and_salaries()
    {
        return $this->wages_and_salaries;
    }
    /**
     * Set wages_and_salaries value
     * @param int $wages_and_salaries
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public function setWages_and_salaries($wages_and_salaries = null)
    {
        // validation for constraint: int
        if (!is_null($wages_and_salaries) && !(is_int($wages_and_salaries) || ctype_digit($wages_and_salaries))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($wages_and_salaries, true), gettype($wages_and_salaries)), __LINE__);
        }
        $this->wages_and_salaries = $wages_and_salaries;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanyProfitAndLossV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
