<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanySummaryV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanySummaryV2 extends AbstractStructBase
{
    /**
     * The company_status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyStatusV2
     */
    public $company_status;
    /**
     * The credit_rating
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyCreditRatingV2
     */
    public $credit_rating;
    /**
     * The latest_shareholders_equity_figure
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $latest_shareholders_equity_figure;
    /**
     * The latest_turnover_figure
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $latest_turnover_figure;
    /**
     * The main_activity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyActivityV2
     */
    public $main_activity;
    /**
     * The country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country;
    /**
     * The number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $number;
    /**
     * The company_registration_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $company_registration_number;
    /**
     * The business_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $business_name;
    /**
     * Constructor method for CreditsafeCompanySummaryV2
     * @uses CreditsafeCompanySummaryV2::setCompany_status()
     * @uses CreditsafeCompanySummaryV2::setCredit_rating()
     * @uses CreditsafeCompanySummaryV2::setLatest_shareholders_equity_figure()
     * @uses CreditsafeCompanySummaryV2::setLatest_turnover_figure()
     * @uses CreditsafeCompanySummaryV2::setMain_activity()
     * @uses CreditsafeCompanySummaryV2::setCountry()
     * @uses CreditsafeCompanySummaryV2::setNumber()
     * @uses CreditsafeCompanySummaryV2::setCompany_registration_number()
     * @uses CreditsafeCompanySummaryV2::setBusiness_name()
     * @param \StructType\CreditsafeCompanyStatusV2 $company_status
     * @param \StructType\CreditsafeCompanyCreditRatingV2 $credit_rating
     * @param int $latest_shareholders_equity_figure
     * @param int $latest_turnover_figure
     * @param \StructType\CreditsafeCompanyActivityV2 $main_activity
     * @param string $country
     * @param string $number
     * @param string $company_registration_number
     * @param string $business_name
     */
    public function __construct(\StructType\CreditsafeCompanyStatusV2 $company_status = null, \StructType\CreditsafeCompanyCreditRatingV2 $credit_rating = null, $latest_shareholders_equity_figure = null, $latest_turnover_figure = null, \StructType\CreditsafeCompanyActivityV2 $main_activity = null, $country = null, $number = null, $company_registration_number = null, $business_name = null)
    {
        $this
            ->setCompany_status($company_status)
            ->setCredit_rating($credit_rating)
            ->setLatest_shareholders_equity_figure($latest_shareholders_equity_figure)
            ->setLatest_turnover_figure($latest_turnover_figure)
            ->setMain_activity($main_activity)
            ->setCountry($country)
            ->setNumber($number)
            ->setCompany_registration_number($company_registration_number)
            ->setBusiness_name($business_name);
    }
    /**
     * Get company_status value
     * @return \StructType\CreditsafeCompanyStatusV2|null
     */
    public function getCompany_status()
    {
        return $this->company_status;
    }
    /**
     * Set company_status value
     * @param \StructType\CreditsafeCompanyStatusV2 $company_status
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setCompany_status(\StructType\CreditsafeCompanyStatusV2 $company_status = null)
    {
        $this->company_status = $company_status;
        return $this;
    }
    /**
     * Get credit_rating value
     * @return \StructType\CreditsafeCompanyCreditRatingV2|null
     */
    public function getCredit_rating()
    {
        return $this->credit_rating;
    }
    /**
     * Set credit_rating value
     * @param \StructType\CreditsafeCompanyCreditRatingV2 $credit_rating
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setCredit_rating(\StructType\CreditsafeCompanyCreditRatingV2 $credit_rating = null)
    {
        $this->credit_rating = $credit_rating;
        return $this;
    }
    /**
     * Get latest_shareholders_equity_figure value
     * @return int|null
     */
    public function getLatest_shareholders_equity_figure()
    {
        return $this->latest_shareholders_equity_figure;
    }
    /**
     * Set latest_shareholders_equity_figure value
     * @param int $latest_shareholders_equity_figure
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setLatest_shareholders_equity_figure($latest_shareholders_equity_figure = null)
    {
        // validation for constraint: int
        if (!is_null($latest_shareholders_equity_figure) && !(is_int($latest_shareholders_equity_figure) || ctype_digit($latest_shareholders_equity_figure))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($latest_shareholders_equity_figure, true), gettype($latest_shareholders_equity_figure)), __LINE__);
        }
        $this->latest_shareholders_equity_figure = $latest_shareholders_equity_figure;
        return $this;
    }
    /**
     * Get latest_turnover_figure value
     * @return int|null
     */
    public function getLatest_turnover_figure()
    {
        return $this->latest_turnover_figure;
    }
    /**
     * Set latest_turnover_figure value
     * @param int $latest_turnover_figure
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setLatest_turnover_figure($latest_turnover_figure = null)
    {
        // validation for constraint: int
        if (!is_null($latest_turnover_figure) && !(is_int($latest_turnover_figure) || ctype_digit($latest_turnover_figure))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($latest_turnover_figure, true), gettype($latest_turnover_figure)), __LINE__);
        }
        $this->latest_turnover_figure = $latest_turnover_figure;
        return $this;
    }
    /**
     * Get main_activity value
     * @return \StructType\CreditsafeCompanyActivityV2|null
     */
    public function getMain_activity()
    {
        return $this->main_activity;
    }
    /**
     * Set main_activity value
     * @param \StructType\CreditsafeCompanyActivityV2 $main_activity
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setMain_activity(\StructType\CreditsafeCompanyActivityV2 $main_activity = null)
    {
        $this->main_activity = $main_activity;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->number;
    }
    /**
     * Set number value
     * @param string $number
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->number = $number;
        return $this;
    }
    /**
     * Get company_registration_number value
     * @return string|null
     */
    public function getCompany_registration_number()
    {
        return $this->company_registration_number;
    }
    /**
     * Set company_registration_number value
     * @param string $company_registration_number
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setCompany_registration_number($company_registration_number = null)
    {
        // validation for constraint: string
        if (!is_null($company_registration_number) && !is_string($company_registration_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_registration_number, true), gettype($company_registration_number)), __LINE__);
        }
        $this->company_registration_number = $company_registration_number;
        return $this;
    }
    /**
     * Get business_name value
     * @return string|null
     */
    public function getBusiness_name()
    {
        return $this->business_name;
    }
    /**
     * Set business_name value
     * @param string $business_name
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public function setBusiness_name($business_name = null)
    {
        // validation for constraint: string
        if (!is_null($business_name) && !is_string($business_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($business_name, true), gettype($business_name)), __LINE__);
        }
        $this->business_name = $business_name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeCompanySummaryV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
