<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeLtdOtherInformation StructType
 * @subpackage Structs
 */
class CreditsafeLtdOtherInformation extends AbstractStructBase
{
    /**
     * The bankers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeBankerArray
     */
    public $bankers;
    /**
     * The advisors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeAdvisorArray
     */
    public $advisors;
    /**
     * The employees_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafeEmployeeInformationArray
     */
    public $employees_information;
    /**
     * Constructor method for CreditsafeLtdOtherInformation
     * @uses CreditsafeLtdOtherInformation::setBankers()
     * @uses CreditsafeLtdOtherInformation::setAdvisors()
     * @uses CreditsafeLtdOtherInformation::setEmployees_information()
     * @param \ArrayType\CreditsafeBankerArray $bankers
     * @param \ArrayType\CreditsafeAdvisorArray $advisors
     * @param \ArrayType\CreditsafeEmployeeInformationArray $employees_information
     */
    public function __construct(\ArrayType\CreditsafeBankerArray $bankers = null, \ArrayType\CreditsafeAdvisorArray $advisors = null, \ArrayType\CreditsafeEmployeeInformationArray $employees_information = null)
    {
        $this
            ->setBankers($bankers)
            ->setAdvisors($advisors)
            ->setEmployees_information($employees_information);
    }
    /**
     * Get bankers value
     * @return \ArrayType\CreditsafeBankerArray|null
     */
    public function getBankers()
    {
        return $this->bankers;
    }
    /**
     * Set bankers value
     * @param \ArrayType\CreditsafeBankerArray $bankers
     * @return \StructType\CreditsafeLtdOtherInformation
     */
    public function setBankers(\ArrayType\CreditsafeBankerArray $bankers = null)
    {
        $this->bankers = $bankers;
        return $this;
    }
    /**
     * Get advisors value
     * @return \ArrayType\CreditsafeAdvisorArray|null
     */
    public function getAdvisors()
    {
        return $this->advisors;
    }
    /**
     * Set advisors value
     * @param \ArrayType\CreditsafeAdvisorArray $advisors
     * @return \StructType\CreditsafeLtdOtherInformation
     */
    public function setAdvisors(\ArrayType\CreditsafeAdvisorArray $advisors = null)
    {
        $this->advisors = $advisors;
        return $this;
    }
    /**
     * Get employees_information value
     * @return \ArrayType\CreditsafeEmployeeInformationArray|null
     */
    public function getEmployees_information()
    {
        return $this->employees_information;
    }
    /**
     * Set employees_information value
     * @param \ArrayType\CreditsafeEmployeeInformationArray $employees_information
     * @return \StructType\CreditsafeLtdOtherInformation
     */
    public function setEmployees_information(\ArrayType\CreditsafeEmployeeInformationArray $employees_information = null)
    {
        $this->employees_information = $employees_information;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeLtdOtherInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
