<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafePersonDirectorsV2 StructType
 * @subpackage Structs
 */
class CreditsafePersonDirectorsV2 extends AbstractStructBase
{
    /**
     * The current_directors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafePersonDirectorV2Array
     */
    public $current_directors;
    /**
     * The previous_directors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\CreditsafePersonPreviousDirectorV2Array
     */
    public $previous_directors;
    /**
     * Constructor method for CreditsafePersonDirectorsV2
     * @uses CreditsafePersonDirectorsV2::setCurrent_directors()
     * @uses CreditsafePersonDirectorsV2::setPrevious_directors()
     * @param \ArrayType\CreditsafePersonDirectorV2Array $current_directors
     * @param \ArrayType\CreditsafePersonPreviousDirectorV2Array $previous_directors
     */
    public function __construct(\ArrayType\CreditsafePersonDirectorV2Array $current_directors = null, \ArrayType\CreditsafePersonPreviousDirectorV2Array $previous_directors = null)
    {
        $this
            ->setCurrent_directors($current_directors)
            ->setPrevious_directors($previous_directors);
    }
    /**
     * Get current_directors value
     * @return \ArrayType\CreditsafePersonDirectorV2Array|null
     */
    public function getCurrent_directors()
    {
        return $this->current_directors;
    }
    /**
     * Set current_directors value
     * @param \ArrayType\CreditsafePersonDirectorV2Array $current_directors
     * @return \StructType\CreditsafePersonDirectorsV2
     */
    public function setCurrent_directors(\ArrayType\CreditsafePersonDirectorV2Array $current_directors = null)
    {
        $this->current_directors = $current_directors;
        return $this;
    }
    /**
     * Get previous_directors value
     * @return \ArrayType\CreditsafePersonPreviousDirectorV2Array|null
     */
    public function getPrevious_directors()
    {
        return $this->previous_directors;
    }
    /**
     * Set previous_directors value
     * @param \ArrayType\CreditsafePersonPreviousDirectorV2Array $previous_directors
     * @return \StructType\CreditsafePersonDirectorsV2
     */
    public function setPrevious_directors(\ArrayType\CreditsafePersonPreviousDirectorV2Array $previous_directors = null)
    {
        $this->previous_directors = $previous_directors;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafePersonDirectorsV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
