<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeProfitAndLossFigures StructType
 * @subpackage Structs
 */
class CreditsafeProfitAndLossFigures extends AbstractStructBase
{
    /**
     * The year_end_date
     * @var string
     */
    public $year_end_date;
    /**
     * The number_of_weeks
     * @var int
     */
    public $number_of_weeks;
    /**
     * The currency
     * @var string
     */
    public $currency;
    /**
     * The consolidated_accounts
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $consolidated_accounts;
    /**
     * The revenue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $revenue;
    /**
     * The operating_costs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $operating_costs;
    /**
     * The operating_profit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $operating_profit;
    /**
     * The wages_and_salaries
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $wages_and_salaries;
    /**
     * The pension_costs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $pension_costs;
    /**
     * The depreciation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $depreciation;
    /**
     * The amortisation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $amortisation;
    /**
     * The financial_income
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $financial_income;
    /**
     * The financial_expenses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $financial_expenses;
    /**
     * The extraordinary_income
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $extraordinary_income;
    /**
     * The extraordinary_costs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $extraordinary_costs;
    /**
     * The profit_before_tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $profit_before_tax;
    /**
     * The tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tax;
    /**
     * The profit_after_tax
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $profit_after_tax;
    /**
     * The dividends
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $dividends;
    /**
     * The minority_interests
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $minority_interests;
    /**
     * The other_appropriations
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $other_appropriations;
    /**
     * The retained_profit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $retained_profit;
    /**
     * Constructor method for CreditsafeProfitAndLossFigures
     * @uses CreditsafeProfitAndLossFigures::setYear_end_date()
     * @uses CreditsafeProfitAndLossFigures::setNumber_of_weeks()
     * @uses CreditsafeProfitAndLossFigures::setCurrency()
     * @uses CreditsafeProfitAndLossFigures::setConsolidated_accounts()
     * @uses CreditsafeProfitAndLossFigures::setRevenue()
     * @uses CreditsafeProfitAndLossFigures::setOperating_costs()
     * @uses CreditsafeProfitAndLossFigures::setOperating_profit()
     * @uses CreditsafeProfitAndLossFigures::setWages_and_salaries()
     * @uses CreditsafeProfitAndLossFigures::setPension_costs()
     * @uses CreditsafeProfitAndLossFigures::setDepreciation()
     * @uses CreditsafeProfitAndLossFigures::setAmortisation()
     * @uses CreditsafeProfitAndLossFigures::setFinancial_income()
     * @uses CreditsafeProfitAndLossFigures::setFinancial_expenses()
     * @uses CreditsafeProfitAndLossFigures::setExtraordinary_income()
     * @uses CreditsafeProfitAndLossFigures::setExtraordinary_costs()
     * @uses CreditsafeProfitAndLossFigures::setProfit_before_tax()
     * @uses CreditsafeProfitAndLossFigures::setTax()
     * @uses CreditsafeProfitAndLossFigures::setProfit_after_tax()
     * @uses CreditsafeProfitAndLossFigures::setDividends()
     * @uses CreditsafeProfitAndLossFigures::setMinority_interests()
     * @uses CreditsafeProfitAndLossFigures::setOther_appropriations()
     * @uses CreditsafeProfitAndLossFigures::setRetained_profit()
     * @param string $year_end_date
     * @param int $number_of_weeks
     * @param string $currency
     * @param bool $consolidated_accounts
     * @param float $revenue
     * @param float $operating_costs
     * @param float $operating_profit
     * @param float $wages_and_salaries
     * @param float $pension_costs
     * @param float $depreciation
     * @param float $amortisation
     * @param float $financial_income
     * @param float $financial_expenses
     * @param float $extraordinary_income
     * @param float $extraordinary_costs
     * @param float $profit_before_tax
     * @param float $tax
     * @param float $profit_after_tax
     * @param float $dividends
     * @param float $minority_interests
     * @param float $other_appropriations
     * @param float $retained_profit
     */
    public function __construct($year_end_date = null, $number_of_weeks = null, $currency = null, $consolidated_accounts = null, $revenue = null, $operating_costs = null, $operating_profit = null, $wages_and_salaries = null, $pension_costs = null, $depreciation = null, $amortisation = null, $financial_income = null, $financial_expenses = null, $extraordinary_income = null, $extraordinary_costs = null, $profit_before_tax = null, $tax = null, $profit_after_tax = null, $dividends = null, $minority_interests = null, $other_appropriations = null, $retained_profit = null)
    {
        $this
            ->setYear_end_date($year_end_date)
            ->setNumber_of_weeks($number_of_weeks)
            ->setCurrency($currency)
            ->setConsolidated_accounts($consolidated_accounts)
            ->setRevenue($revenue)
            ->setOperating_costs($operating_costs)
            ->setOperating_profit($operating_profit)
            ->setWages_and_salaries($wages_and_salaries)
            ->setPension_costs($pension_costs)
            ->setDepreciation($depreciation)
            ->setAmortisation($amortisation)
            ->setFinancial_income($financial_income)
            ->setFinancial_expenses($financial_expenses)
            ->setExtraordinary_income($extraordinary_income)
            ->setExtraordinary_costs($extraordinary_costs)
            ->setProfit_before_tax($profit_before_tax)
            ->setTax($tax)
            ->setProfit_after_tax($profit_after_tax)
            ->setDividends($dividends)
            ->setMinority_interests($minority_interests)
            ->setOther_appropriations($other_appropriations)
            ->setRetained_profit($retained_profit);
    }
    /**
     * Get year_end_date value
     * @return string|null
     */
    public function getYear_end_date()
    {
        return $this->year_end_date;
    }
    /**
     * Set year_end_date value
     * @param string $year_end_date
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setYear_end_date($year_end_date = null)
    {
        // validation for constraint: string
        if (!is_null($year_end_date) && !is_string($year_end_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($year_end_date, true), gettype($year_end_date)), __LINE__);
        }
        $this->year_end_date = $year_end_date;
        return $this;
    }
    /**
     * Get number_of_weeks value
     * @return int|null
     */
    public function getNumber_of_weeks()
    {
        return $this->number_of_weeks;
    }
    /**
     * Set number_of_weeks value
     * @param int $number_of_weeks
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setNumber_of_weeks($number_of_weeks = null)
    {
        // validation for constraint: int
        if (!is_null($number_of_weeks) && !(is_int($number_of_weeks) || ctype_digit($number_of_weeks))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number_of_weeks, true), gettype($number_of_weeks)), __LINE__);
        }
        $this->number_of_weeks = $number_of_weeks;
        return $this;
    }
    /**
     * Get currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->currency;
    }
    /**
     * Set currency value
     * @param string $currency
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        $this->currency = $currency;
        return $this;
    }
    /**
     * Get consolidated_accounts value
     * @return bool|null
     */
    public function getConsolidated_accounts()
    {
        return $this->consolidated_accounts;
    }
    /**
     * Set consolidated_accounts value
     * @param bool $consolidated_accounts
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setConsolidated_accounts($consolidated_accounts = null)
    {
        // validation for constraint: boolean
        if (!is_null($consolidated_accounts) && !is_bool($consolidated_accounts)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($consolidated_accounts, true), gettype($consolidated_accounts)), __LINE__);
        }
        $this->consolidated_accounts = $consolidated_accounts;
        return $this;
    }
    /**
     * Get revenue value
     * @return float|null
     */
    public function getRevenue()
    {
        return $this->revenue;
    }
    /**
     * Set revenue value
     * @param float $revenue
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setRevenue($revenue = null)
    {
        // validation for constraint: float
        if (!is_null($revenue) && !(is_float($revenue) || is_numeric($revenue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($revenue, true), gettype($revenue)), __LINE__);
        }
        $this->revenue = $revenue;
        return $this;
    }
    /**
     * Get operating_costs value
     * @return float|null
     */
    public function getOperating_costs()
    {
        return $this->operating_costs;
    }
    /**
     * Set operating_costs value
     * @param float $operating_costs
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setOperating_costs($operating_costs = null)
    {
        // validation for constraint: float
        if (!is_null($operating_costs) && !(is_float($operating_costs) || is_numeric($operating_costs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($operating_costs, true), gettype($operating_costs)), __LINE__);
        }
        $this->operating_costs = $operating_costs;
        return $this;
    }
    /**
     * Get operating_profit value
     * @return float|null
     */
    public function getOperating_profit()
    {
        return $this->operating_profit;
    }
    /**
     * Set operating_profit value
     * @param float $operating_profit
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setOperating_profit($operating_profit = null)
    {
        // validation for constraint: float
        if (!is_null($operating_profit) && !(is_float($operating_profit) || is_numeric($operating_profit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($operating_profit, true), gettype($operating_profit)), __LINE__);
        }
        $this->operating_profit = $operating_profit;
        return $this;
    }
    /**
     * Get wages_and_salaries value
     * @return float|null
     */
    public function getWages_and_salaries()
    {
        return $this->wages_and_salaries;
    }
    /**
     * Set wages_and_salaries value
     * @param float $wages_and_salaries
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setWages_and_salaries($wages_and_salaries = null)
    {
        // validation for constraint: float
        if (!is_null($wages_and_salaries) && !(is_float($wages_and_salaries) || is_numeric($wages_and_salaries))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($wages_and_salaries, true), gettype($wages_and_salaries)), __LINE__);
        }
        $this->wages_and_salaries = $wages_and_salaries;
        return $this;
    }
    /**
     * Get pension_costs value
     * @return float|null
     */
    public function getPension_costs()
    {
        return $this->pension_costs;
    }
    /**
     * Set pension_costs value
     * @param float $pension_costs
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setPension_costs($pension_costs = null)
    {
        // validation for constraint: float
        if (!is_null($pension_costs) && !(is_float($pension_costs) || is_numeric($pension_costs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pension_costs, true), gettype($pension_costs)), __LINE__);
        }
        $this->pension_costs = $pension_costs;
        return $this;
    }
    /**
     * Get depreciation value
     * @return float|null
     */
    public function getDepreciation()
    {
        return $this->depreciation;
    }
    /**
     * Set depreciation value
     * @param float $depreciation
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setDepreciation($depreciation = null)
    {
        // validation for constraint: float
        if (!is_null($depreciation) && !(is_float($depreciation) || is_numeric($depreciation))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($depreciation, true), gettype($depreciation)), __LINE__);
        }
        $this->depreciation = $depreciation;
        return $this;
    }
    /**
     * Get amortisation value
     * @return float|null
     */
    public function getAmortisation()
    {
        return $this->amortisation;
    }
    /**
     * Set amortisation value
     * @param float $amortisation
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setAmortisation($amortisation = null)
    {
        // validation for constraint: float
        if (!is_null($amortisation) && !(is_float($amortisation) || is_numeric($amortisation))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amortisation, true), gettype($amortisation)), __LINE__);
        }
        $this->amortisation = $amortisation;
        return $this;
    }
    /**
     * Get financial_income value
     * @return float|null
     */
    public function getFinancial_income()
    {
        return $this->financial_income;
    }
    /**
     * Set financial_income value
     * @param float $financial_income
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setFinancial_income($financial_income = null)
    {
        // validation for constraint: float
        if (!is_null($financial_income) && !(is_float($financial_income) || is_numeric($financial_income))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($financial_income, true), gettype($financial_income)), __LINE__);
        }
        $this->financial_income = $financial_income;
        return $this;
    }
    /**
     * Get financial_expenses value
     * @return float|null
     */
    public function getFinancial_expenses()
    {
        return $this->financial_expenses;
    }
    /**
     * Set financial_expenses value
     * @param float $financial_expenses
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setFinancial_expenses($financial_expenses = null)
    {
        // validation for constraint: float
        if (!is_null($financial_expenses) && !(is_float($financial_expenses) || is_numeric($financial_expenses))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($financial_expenses, true), gettype($financial_expenses)), __LINE__);
        }
        $this->financial_expenses = $financial_expenses;
        return $this;
    }
    /**
     * Get extraordinary_income value
     * @return float|null
     */
    public function getExtraordinary_income()
    {
        return $this->extraordinary_income;
    }
    /**
     * Set extraordinary_income value
     * @param float $extraordinary_income
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setExtraordinary_income($extraordinary_income = null)
    {
        // validation for constraint: float
        if (!is_null($extraordinary_income) && !(is_float($extraordinary_income) || is_numeric($extraordinary_income))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($extraordinary_income, true), gettype($extraordinary_income)), __LINE__);
        }
        $this->extraordinary_income = $extraordinary_income;
        return $this;
    }
    /**
     * Get extraordinary_costs value
     * @return float|null
     */
    public function getExtraordinary_costs()
    {
        return $this->extraordinary_costs;
    }
    /**
     * Set extraordinary_costs value
     * @param float $extraordinary_costs
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setExtraordinary_costs($extraordinary_costs = null)
    {
        // validation for constraint: float
        if (!is_null($extraordinary_costs) && !(is_float($extraordinary_costs) || is_numeric($extraordinary_costs))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($extraordinary_costs, true), gettype($extraordinary_costs)), __LINE__);
        }
        $this->extraordinary_costs = $extraordinary_costs;
        return $this;
    }
    /**
     * Get profit_before_tax value
     * @return float|null
     */
    public function getProfit_before_tax()
    {
        return $this->profit_before_tax;
    }
    /**
     * Set profit_before_tax value
     * @param float $profit_before_tax
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setProfit_before_tax($profit_before_tax = null)
    {
        // validation for constraint: float
        if (!is_null($profit_before_tax) && !(is_float($profit_before_tax) || is_numeric($profit_before_tax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($profit_before_tax, true), gettype($profit_before_tax)), __LINE__);
        }
        $this->profit_before_tax = $profit_before_tax;
        return $this;
    }
    /**
     * Get tax value
     * @return float|null
     */
    public function getTax()
    {
        return $this->tax;
    }
    /**
     * Set tax value
     * @param float $tax
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setTax($tax = null)
    {
        // validation for constraint: float
        if (!is_null($tax) && !(is_float($tax) || is_numeric($tax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($tax, true), gettype($tax)), __LINE__);
        }
        $this->tax = $tax;
        return $this;
    }
    /**
     * Get profit_after_tax value
     * @return float|null
     */
    public function getProfit_after_tax()
    {
        return $this->profit_after_tax;
    }
    /**
     * Set profit_after_tax value
     * @param float $profit_after_tax
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setProfit_after_tax($profit_after_tax = null)
    {
        // validation for constraint: float
        if (!is_null($profit_after_tax) && !(is_float($profit_after_tax) || is_numeric($profit_after_tax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($profit_after_tax, true), gettype($profit_after_tax)), __LINE__);
        }
        $this->profit_after_tax = $profit_after_tax;
        return $this;
    }
    /**
     * Get dividends value
     * @return float|null
     */
    public function getDividends()
    {
        return $this->dividends;
    }
    /**
     * Set dividends value
     * @param float $dividends
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setDividends($dividends = null)
    {
        // validation for constraint: float
        if (!is_null($dividends) && !(is_float($dividends) || is_numeric($dividends))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($dividends, true), gettype($dividends)), __LINE__);
        }
        $this->dividends = $dividends;
        return $this;
    }
    /**
     * Get minority_interests value
     * @return float|null
     */
    public function getMinority_interests()
    {
        return $this->minority_interests;
    }
    /**
     * Set minority_interests value
     * @param float $minority_interests
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setMinority_interests($minority_interests = null)
    {
        // validation for constraint: float
        if (!is_null($minority_interests) && !(is_float($minority_interests) || is_numeric($minority_interests))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($minority_interests, true), gettype($minority_interests)), __LINE__);
        }
        $this->minority_interests = $minority_interests;
        return $this;
    }
    /**
     * Get other_appropriations value
     * @return float|null
     */
    public function getOther_appropriations()
    {
        return $this->other_appropriations;
    }
    /**
     * Set other_appropriations value
     * @param float $other_appropriations
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setOther_appropriations($other_appropriations = null)
    {
        // validation for constraint: float
        if (!is_null($other_appropriations) && !(is_float($other_appropriations) || is_numeric($other_appropriations))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($other_appropriations, true), gettype($other_appropriations)), __LINE__);
        }
        $this->other_appropriations = $other_appropriations;
        return $this;
    }
    /**
     * Get retained_profit value
     * @return float|null
     */
    public function getRetained_profit()
    {
        return $this->retained_profit;
    }
    /**
     * Set retained_profit value
     * @param float $retained_profit
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public function setRetained_profit($retained_profit = null)
    {
        // validation for constraint: float
        if (!is_null($retained_profit) && !(is_float($retained_profit) || is_numeric($retained_profit))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($retained_profit, true), gettype($retained_profit)), __LINE__);
        }
        $this->retained_profit = $retained_profit;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreditsafeProfitAndLossFigures
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
