<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessAnnualFinancialStatement StructType
 * @subpackage Structs
 */
class DutchBusinessAnnualFinancialStatement extends AbstractStructBase
{
    /**
     * The dossier_number
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $dossier_number;
    /**
     * The year
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $year;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $type;
    /**
     * The document
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $document;
    /**
     * Constructor method for DutchBusinessAnnualFinancialStatement
     * @uses DutchBusinessAnnualFinancialStatement::setDossier_number()
     * @uses DutchBusinessAnnualFinancialStatement::setYear()
     * @uses DutchBusinessAnnualFinancialStatement::setType()
     * @uses DutchBusinessAnnualFinancialStatement::setDocument()
     * @param string $dossier_number
     * @param int $year
     * @param string $type
     * @param string $document
     */
    public function __construct($dossier_number = null, $year = null, $type = null, $document = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setYear($year)
            ->setType($type)
            ->setDocument($document);
    }
    /**
     * Get dossier_number value
     * @return string
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessAnnualFinancialStatement
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get year value
     * @return int
     */
    public function getYear()
    {
        return $this->year;
    }
    /**
     * Set year value
     * @param int $year
     * @return \StructType\DutchBusinessAnnualFinancialStatement
     */
    public function setYear($year = null)
    {
        // validation for constraint: int
        if (!is_null($year) && !(is_int($year) || ctype_digit($year))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($year, true), gettype($year)), __LINE__);
        }
        $this->year = $year;
        return $this;
    }
    /**
     * Get type value
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\DutchBusinessAnnualFinancialStatement
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get document value
     * @return string
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\DutchBusinessAnnualFinancialStatement
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessAnnualFinancialStatement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
