<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessEnterpriseV3 StructType
 * @subpackage Structs
 */
class DutchBusinessEnterpriseV3 extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The registration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $registration;
    /**
     * The legal_form_text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $legal_form_text;
    /**
     * The activity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $activity;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The incorporation_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV3
     */
    public $incorporation_date;
    /**
     * The founding_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV3
     */
    public $founding_date;
    /**
     * The discontinuation_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV3
     */
    public $discontinuation_date;
    /**
     * The date_since
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV3
     */
    public $date_since;
    /**
     * The personnel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessPersonnelInfoV3
     */
    public $personnel;
    /**
     * The remarks
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $remarks;
    /**
     * The sbi_codes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessSbiCodeV3Array
     */
    public $sbi_codes;
    /**
     * The trade_names
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $trade_names;
    /**
     * Constructor method for DutchBusinessEnterpriseV3
     * @uses DutchBusinessEnterpriseV3::setName()
     * @uses DutchBusinessEnterpriseV3::setRegistration()
     * @uses DutchBusinessEnterpriseV3::setLegal_form_text()
     * @uses DutchBusinessEnterpriseV3::setActivity()
     * @uses DutchBusinessEnterpriseV3::setDescription()
     * @uses DutchBusinessEnterpriseV3::setIncorporation_date()
     * @uses DutchBusinessEnterpriseV3::setFounding_date()
     * @uses DutchBusinessEnterpriseV3::setDiscontinuation_date()
     * @uses DutchBusinessEnterpriseV3::setDate_since()
     * @uses DutchBusinessEnterpriseV3::setPersonnel()
     * @uses DutchBusinessEnterpriseV3::setRemarks()
     * @uses DutchBusinessEnterpriseV3::setSbi_codes()
     * @uses DutchBusinessEnterpriseV3::setTrade_names()
     * @param string $name
     * @param string $registration
     * @param string $legal_form_text
     * @param string $activity
     * @param string $description
     * @param \StructType\DutchBusinessDateV3 $incorporation_date
     * @param \StructType\DutchBusinessDateV3 $founding_date
     * @param \StructType\DutchBusinessDateV3 $discontinuation_date
     * @param \StructType\DutchBusinessDateV3 $date_since
     * @param \StructType\DutchBusinessPersonnelInfoV3 $personnel
     * @param \ArrayType\StringArray $remarks
     * @param \ArrayType\DutchBusinessSbiCodeV3Array $sbi_codes
     * @param \ArrayType\StringArray $trade_names
     */
    public function __construct($name = null, $registration = null, $legal_form_text = null, $activity = null, $description = null, \StructType\DutchBusinessDateV3 $incorporation_date = null, \StructType\DutchBusinessDateV3 $founding_date = null, \StructType\DutchBusinessDateV3 $discontinuation_date = null, \StructType\DutchBusinessDateV3 $date_since = null, \StructType\DutchBusinessPersonnelInfoV3 $personnel = null, \ArrayType\StringArray $remarks = null, \ArrayType\DutchBusinessSbiCodeV3Array $sbi_codes = null, \ArrayType\StringArray $trade_names = null)
    {
        $this
            ->setName($name)
            ->setRegistration($registration)
            ->setLegal_form_text($legal_form_text)
            ->setActivity($activity)
            ->setDescription($description)
            ->setIncorporation_date($incorporation_date)
            ->setFounding_date($founding_date)
            ->setDiscontinuation_date($discontinuation_date)
            ->setDate_since($date_since)
            ->setPersonnel($personnel)
            ->setRemarks($remarks)
            ->setSbi_codes($sbi_codes)
            ->setTrade_names($trade_names);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get registration value
     * @return string|null
     */
    public function getRegistration()
    {
        return $this->registration;
    }
    /**
     * Set registration value
     * @param string $registration
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setRegistration($registration = null)
    {
        // validation for constraint: string
        if (!is_null($registration) && !is_string($registration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registration, true), gettype($registration)), __LINE__);
        }
        $this->registration = $registration;
        return $this;
    }
    /**
     * Get legal_form_text value
     * @return string|null
     */
    public function getLegal_form_text()
    {
        return $this->legal_form_text;
    }
    /**
     * Set legal_form_text value
     * @param string $legal_form_text
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setLegal_form_text($legal_form_text = null)
    {
        // validation for constraint: string
        if (!is_null($legal_form_text) && !is_string($legal_form_text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_form_text, true), gettype($legal_form_text)), __LINE__);
        }
        $this->legal_form_text = $legal_form_text;
        return $this;
    }
    /**
     * Get activity value
     * @return string|null
     */
    public function getActivity()
    {
        return $this->activity;
    }
    /**
     * Set activity value
     * @param string $activity
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setActivity($activity = null)
    {
        // validation for constraint: string
        if (!is_null($activity) && !is_string($activity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activity, true), gettype($activity)), __LINE__);
        }
        $this->activity = $activity;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get incorporation_date value
     * @return \StructType\DutchBusinessDateV3|null
     */
    public function getIncorporation_date()
    {
        return $this->incorporation_date;
    }
    /**
     * Set incorporation_date value
     * @param \StructType\DutchBusinessDateV3 $incorporation_date
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setIncorporation_date(\StructType\DutchBusinessDateV3 $incorporation_date = null)
    {
        $this->incorporation_date = $incorporation_date;
        return $this;
    }
    /**
     * Get founding_date value
     * @return \StructType\DutchBusinessDateV3|null
     */
    public function getFounding_date()
    {
        return $this->founding_date;
    }
    /**
     * Set founding_date value
     * @param \StructType\DutchBusinessDateV3 $founding_date
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setFounding_date(\StructType\DutchBusinessDateV3 $founding_date = null)
    {
        $this->founding_date = $founding_date;
        return $this;
    }
    /**
     * Get discontinuation_date value
     * @return \StructType\DutchBusinessDateV3|null
     */
    public function getDiscontinuation_date()
    {
        return $this->discontinuation_date;
    }
    /**
     * Set discontinuation_date value
     * @param \StructType\DutchBusinessDateV3 $discontinuation_date
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setDiscontinuation_date(\StructType\DutchBusinessDateV3 $discontinuation_date = null)
    {
        $this->discontinuation_date = $discontinuation_date;
        return $this;
    }
    /**
     * Get date_since value
     * @return \StructType\DutchBusinessDateV3|null
     */
    public function getDate_since()
    {
        return $this->date_since;
    }
    /**
     * Set date_since value
     * @param \StructType\DutchBusinessDateV3 $date_since
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setDate_since(\StructType\DutchBusinessDateV3 $date_since = null)
    {
        $this->date_since = $date_since;
        return $this;
    }
    /**
     * Get personnel value
     * @return \StructType\DutchBusinessPersonnelInfoV3|null
     */
    public function getPersonnel()
    {
        return $this->personnel;
    }
    /**
     * Set personnel value
     * @param \StructType\DutchBusinessPersonnelInfoV3 $personnel
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setPersonnel(\StructType\DutchBusinessPersonnelInfoV3 $personnel = null)
    {
        $this->personnel = $personnel;
        return $this;
    }
    /**
     * Get remarks value
     * @return \ArrayType\StringArray|null
     */
    public function getRemarks()
    {
        return $this->remarks;
    }
    /**
     * Set remarks value
     * @param \ArrayType\StringArray $remarks
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setRemarks(\ArrayType\StringArray $remarks = null)
    {
        $this->remarks = $remarks;
        return $this;
    }
    /**
     * Get sbi_codes value
     * @return \ArrayType\DutchBusinessSbiCodeV3Array|null
     */
    public function getSbi_codes()
    {
        return $this->sbi_codes;
    }
    /**
     * Set sbi_codes value
     * @param \ArrayType\DutchBusinessSbiCodeV3Array $sbi_codes
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setSbi_codes(\ArrayType\DutchBusinessSbiCodeV3Array $sbi_codes = null)
    {
        $this->sbi_codes = $sbi_codes;
        return $this;
    }
    /**
     * Get trade_names value
     * @return \ArrayType\StringArray|null
     */
    public function getTrade_names()
    {
        return $this->trade_names;
    }
    /**
     * Set trade_names value
     * @param \ArrayType\StringArray $trade_names
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public function setTrade_names(\ArrayType\StringArray $trade_names = null)
    {
        $this->trade_names = $trade_names;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessEnterpriseV3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
