<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessExtractChangeSet StructType
 * @subpackage Structs
 */
class DutchBusinessExtractChangeSet extends AbstractStructBase
{
    /**
     * The period
     * @var \StructType\DutchBusinessPeriod
     */
    public $period;
    /**
     * The changes
     * @var \ArrayType\StringArray
     */
    public $changes;
    /**
     * Constructor method for DutchBusinessExtractChangeSet
     * @uses DutchBusinessExtractChangeSet::setPeriod()
     * @uses DutchBusinessExtractChangeSet::setChanges()
     * @param \StructType\DutchBusinessPeriod $period
     * @param \ArrayType\StringArray $changes
     */
    public function __construct(\StructType\DutchBusinessPeriod $period = null, \ArrayType\StringArray $changes = null)
    {
        $this
            ->setPeriod($period)
            ->setChanges($changes);
    }
    /**
     * Get period value
     * @return \StructType\DutchBusinessPeriod|null
     */
    public function getPeriod()
    {
        return $this->period;
    }
    /**
     * Set period value
     * @param \StructType\DutchBusinessPeriod $period
     * @return \StructType\DutchBusinessExtractChangeSet
     */
    public function setPeriod(\StructType\DutchBusinessPeriod $period = null)
    {
        $this->period = $period;
        return $this;
    }
    /**
     * Get changes value
     * @return \ArrayType\StringArray|null
     */
    public function getChanges()
    {
        return $this->changes;
    }
    /**
     * Set changes value
     * @param \ArrayType\StringArray $changes
     * @return \StructType\DutchBusinessExtractChangeSet
     */
    public function setChanges(\ArrayType\StringArray $changes = null)
    {
        $this->changes = $changes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessExtractChangeSet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
