<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessExtractHistory StructType
 * @subpackage Structs
 */
class DutchBusinessExtractHistory extends AbstractStructBase
{
    /**
     * The forecast
     * @var \StructType\DutchBusinessExtractChangeForecast
     */
    public $forecast;
    /**
     * The references
     * @var \ArrayType\DutchBusinessExtractReferenceArray
     */
    public $references;
    /**
     * Constructor method for DutchBusinessExtractHistory
     * @uses DutchBusinessExtractHistory::setForecast()
     * @uses DutchBusinessExtractHistory::setReferences()
     * @param \StructType\DutchBusinessExtractChangeForecast $forecast
     * @param \ArrayType\DutchBusinessExtractReferenceArray $references
     */
    public function __construct(\StructType\DutchBusinessExtractChangeForecast $forecast = null, \ArrayType\DutchBusinessExtractReferenceArray $references = null)
    {
        $this
            ->setForecast($forecast)
            ->setReferences($references);
    }
    /**
     * Get forecast value
     * @return \StructType\DutchBusinessExtractChangeForecast|null
     */
    public function getForecast()
    {
        return $this->forecast;
    }
    /**
     * Set forecast value
     * @param \StructType\DutchBusinessExtractChangeForecast $forecast
     * @return \StructType\DutchBusinessExtractHistory
     */
    public function setForecast(\StructType\DutchBusinessExtractChangeForecast $forecast = null)
    {
        $this->forecast = $forecast;
        return $this;
    }
    /**
     * Get references value
     * @return \ArrayType\DutchBusinessExtractReferenceArray|null
     */
    public function getReferences()
    {
        return $this->references;
    }
    /**
     * Set references value
     * @param \ArrayType\DutchBusinessExtractReferenceArray $references
     * @return \StructType\DutchBusinessExtractHistory
     */
    public function setReferences(\ArrayType\DutchBusinessExtractReferenceArray $references = null)
    {
        $this->references = $references;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessExtractHistory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
