<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessGetLeiResult StructType
 * @subpackage Structs
 */
class DutchBusinessGetLeiResult extends AbstractStructBase
{
    /**
     * The lei_code
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $lei_code;
    /**
     * The business_entity
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessLeiBusinessEntity
     */
    public $business_entity;
    /**
     * The registration
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessLeiRegistration
     */
    public $registration;
    /**
     * Constructor method for DutchBusinessGetLeiResult
     * @uses DutchBusinessGetLeiResult::setLei_code()
     * @uses DutchBusinessGetLeiResult::setBusiness_entity()
     * @uses DutchBusinessGetLeiResult::setRegistration()
     * @param string $lei_code
     * @param \StructType\DutchBusinessLeiBusinessEntity $business_entity
     * @param \StructType\DutchBusinessLeiRegistration $registration
     */
    public function __construct($lei_code = null, \StructType\DutchBusinessLeiBusinessEntity $business_entity = null, \StructType\DutchBusinessLeiRegistration $registration = null)
    {
        $this
            ->setLei_code($lei_code)
            ->setBusiness_entity($business_entity)
            ->setRegistration($registration);
    }
    /**
     * Get lei_code value
     * @return string
     */
    public function getLei_code()
    {
        return $this->lei_code;
    }
    /**
     * Set lei_code value
     * @param string $lei_code
     * @return \StructType\DutchBusinessGetLeiResult
     */
    public function setLei_code($lei_code = null)
    {
        // validation for constraint: string
        if (!is_null($lei_code) && !is_string($lei_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lei_code, true), gettype($lei_code)), __LINE__);
        }
        $this->lei_code = $lei_code;
        return $this;
    }
    /**
     * Get business_entity value
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function getBusiness_entity()
    {
        return $this->business_entity;
    }
    /**
     * Set business_entity value
     * @param \StructType\DutchBusinessLeiBusinessEntity $business_entity
     * @return \StructType\DutchBusinessGetLeiResult
     */
    public function setBusiness_entity(\StructType\DutchBusinessLeiBusinessEntity $business_entity = null)
    {
        $this->business_entity = $business_entity;
        return $this;
    }
    /**
     * Get registration value
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function getRegistration()
    {
        return $this->registration;
    }
    /**
     * Set registration value
     * @param \StructType\DutchBusinessLeiRegistration $registration
     * @return \StructType\DutchBusinessGetLeiResult
     */
    public function setRegistration(\StructType\DutchBusinessLeiRegistration $registration = null)
    {
        $this->registration = $registration;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessGetLeiResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
