<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessLookALikeIndividualFeature StructType
 * @subpackage Structs
 */
class DutchBusinessLookALikeIndividualFeature extends AbstractStructBase
{
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The score
     * @var float
     */
    public $score;
    /**
     * The weight
     * @var float
     */
    public $weight;
    /**
     * Constructor method for DutchBusinessLookALikeIndividualFeature
     * @uses DutchBusinessLookALikeIndividualFeature::setName()
     * @uses DutchBusinessLookALikeIndividualFeature::setScore()
     * @uses DutchBusinessLookALikeIndividualFeature::setWeight()
     * @param string $name
     * @param float $score
     * @param float $weight
     */
    public function __construct($name = null, $score = null, $weight = null)
    {
        $this
            ->setName($name)
            ->setScore($score)
            ->setWeight($weight);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\DutchBusinessLookALikeIndividualFeature
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get score value
     * @return float|null
     */
    public function getScore()
    {
        return $this->score;
    }
    /**
     * Set score value
     * @param float $score
     * @return \StructType\DutchBusinessLookALikeIndividualFeature
     */
    public function setScore($score = null)
    {
        // validation for constraint: float
        if (!is_null($score) && !(is_float($score) || is_numeric($score))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($score, true), gettype($score)), __LINE__);
        }
        $this->score = $score;
        return $this;
    }
    /**
     * Get weight value
     * @return float|null
     */
    public function getWeight()
    {
        return $this->weight;
    }
    /**
     * Set weight value
     * @param float $weight
     * @return \StructType\DutchBusinessLookALikeIndividualFeature
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: float
        if (!is_null($weight) && !(is_float($weight) || is_numeric($weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        $this->weight = $weight;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessLookALikeIndividualFeature
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
