<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessPersonV3 StructType
 * @subpackage Structs
 */
class DutchBusinessPersonV3 extends AbstractStructBase
{
    /**
     * The full_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $full_name;
    /**
     * The first_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $first_name;
    /**
     * The title
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $title;
    /**
     * The initials
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $initials;
    /**
     * The last_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $last_name;
    /**
     * The gender
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $gender;
    /**
     * The date_deceased
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV3
     */
    public $date_deceased;
    /**
     * The date_of_birth
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessDateV3
     */
    public $date_of_birth;
    /**
     * The place_of_birth
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $place_of_birth;
    /**
     * The country_of_birth
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country_of_birth;
    /**
     * Constructor method for DutchBusinessPersonV3
     * @uses DutchBusinessPersonV3::setFull_name()
     * @uses DutchBusinessPersonV3::setFirst_name()
     * @uses DutchBusinessPersonV3::setTitle()
     * @uses DutchBusinessPersonV3::setInitials()
     * @uses DutchBusinessPersonV3::setLast_name()
     * @uses DutchBusinessPersonV3::setGender()
     * @uses DutchBusinessPersonV3::setDate_deceased()
     * @uses DutchBusinessPersonV3::setDate_of_birth()
     * @uses DutchBusinessPersonV3::setPlace_of_birth()
     * @uses DutchBusinessPersonV3::setCountry_of_birth()
     * @param string $full_name
     * @param string $first_name
     * @param string $title
     * @param string $initials
     * @param string $last_name
     * @param string $gender
     * @param \StructType\DutchBusinessDateV3 $date_deceased
     * @param \StructType\DutchBusinessDateV3 $date_of_birth
     * @param string $place_of_birth
     * @param string $country_of_birth
     */
    public function __construct($full_name = null, $first_name = null, $title = null, $initials = null, $last_name = null, $gender = null, \StructType\DutchBusinessDateV3 $date_deceased = null, \StructType\DutchBusinessDateV3 $date_of_birth = null, $place_of_birth = null, $country_of_birth = null)
    {
        $this
            ->setFull_name($full_name)
            ->setFirst_name($first_name)
            ->setTitle($title)
            ->setInitials($initials)
            ->setLast_name($last_name)
            ->setGender($gender)
            ->setDate_deceased($date_deceased)
            ->setDate_of_birth($date_of_birth)
            ->setPlace_of_birth($place_of_birth)
            ->setCountry_of_birth($country_of_birth);
    }
    /**
     * Get full_name value
     * @return string|null
     */
    public function getFull_name()
    {
        return $this->full_name;
    }
    /**
     * Set full_name value
     * @param string $full_name
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setFull_name($full_name = null)
    {
        // validation for constraint: string
        if (!is_null($full_name) && !is_string($full_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($full_name, true), gettype($full_name)), __LINE__);
        }
        $this->full_name = $full_name;
        return $this;
    }
    /**
     * Get first_name value
     * @return string|null
     */
    public function getFirst_name()
    {
        return $this->first_name;
    }
    /**
     * Set first_name value
     * @param string $first_name
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setFirst_name($first_name = null)
    {
        // validation for constraint: string
        if (!is_null($first_name) && !is_string($first_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($first_name, true), gettype($first_name)), __LINE__);
        }
        $this->first_name = $first_name;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Get initials value
     * @return string|null
     */
    public function getInitials()
    {
        return $this->initials;
    }
    /**
     * Set initials value
     * @param string $initials
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setInitials($initials = null)
    {
        // validation for constraint: string
        if (!is_null($initials) && !is_string($initials)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($initials, true), gettype($initials)), __LINE__);
        }
        $this->initials = $initials;
        return $this;
    }
    /**
     * Get last_name value
     * @return string|null
     */
    public function getLast_name()
    {
        return $this->last_name;
    }
    /**
     * Set last_name value
     * @param string $last_name
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setLast_name($last_name = null)
    {
        // validation for constraint: string
        if (!is_null($last_name) && !is_string($last_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($last_name, true), gettype($last_name)), __LINE__);
        }
        $this->last_name = $last_name;
        return $this;
    }
    /**
     * Get gender value
     * @return string|null
     */
    public function getGender()
    {
        return $this->gender;
    }
    /**
     * Set gender value
     * @param string $gender
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setGender($gender = null)
    {
        // validation for constraint: string
        if (!is_null($gender) && !is_string($gender)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($gender, true), gettype($gender)), __LINE__);
        }
        $this->gender = $gender;
        return $this;
    }
    /**
     * Get date_deceased value
     * @return \StructType\DutchBusinessDateV3|null
     */
    public function getDate_deceased()
    {
        return $this->date_deceased;
    }
    /**
     * Set date_deceased value
     * @param \StructType\DutchBusinessDateV3 $date_deceased
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setDate_deceased(\StructType\DutchBusinessDateV3 $date_deceased = null)
    {
        $this->date_deceased = $date_deceased;
        return $this;
    }
    /**
     * Get date_of_birth value
     * @return \StructType\DutchBusinessDateV3|null
     */
    public function getDate_of_birth()
    {
        return $this->date_of_birth;
    }
    /**
     * Set date_of_birth value
     * @param \StructType\DutchBusinessDateV3 $date_of_birth
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setDate_of_birth(\StructType\DutchBusinessDateV3 $date_of_birth = null)
    {
        $this->date_of_birth = $date_of_birth;
        return $this;
    }
    /**
     * Get place_of_birth value
     * @return string|null
     */
    public function getPlace_of_birth()
    {
        return $this->place_of_birth;
    }
    /**
     * Set place_of_birth value
     * @param string $place_of_birth
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setPlace_of_birth($place_of_birth = null)
    {
        // validation for constraint: string
        if (!is_null($place_of_birth) && !is_string($place_of_birth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($place_of_birth, true), gettype($place_of_birth)), __LINE__);
        }
        $this->place_of_birth = $place_of_birth;
        return $this;
    }
    /**
     * Get country_of_birth value
     * @return string|null
     */
    public function getCountry_of_birth()
    {
        return $this->country_of_birth;
    }
    /**
     * Set country_of_birth value
     * @param string $country_of_birth
     * @return \StructType\DutchBusinessPersonV3
     */
    public function setCountry_of_birth($country_of_birth = null)
    {
        // validation for constraint: string
        if (!is_null($country_of_birth) && !is_string($country_of_birth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country_of_birth, true), gettype($country_of_birth)), __LINE__);
        }
        $this->country_of_birth = $country_of_birth;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessPersonV3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
