<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessUBOClassifiedRole StructType
 * @subpackage Structs
 */
class DutchBusinessUBOClassifiedRole extends AbstractStructBase
{
    /**
     * The dossier_number
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $dossier_number;
    /**
     * The organisation_name
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $organisation_name;
    /**
     * The function_type
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $function_type;
    /**
     * The title
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $title;
    /**
     * Constructor method for DutchBusinessUBOClassifiedRole
     * @uses DutchBusinessUBOClassifiedRole::setDossier_number()
     * @uses DutchBusinessUBOClassifiedRole::setOrganisation_name()
     * @uses DutchBusinessUBOClassifiedRole::setFunction_type()
     * @uses DutchBusinessUBOClassifiedRole::setTitle()
     * @param string $dossier_number
     * @param string $organisation_name
     * @param string $function_type
     * @param string $title
     */
    public function __construct($dossier_number = null, $organisation_name = null, $function_type = null, $title = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setOrganisation_name($organisation_name)
            ->setFunction_type($function_type)
            ->setTitle($title);
    }
    /**
     * Get dossier_number value
     * @return string
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessUBOClassifiedRole
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get organisation_name value
     * @return string
     */
    public function getOrganisation_name()
    {
        return $this->organisation_name;
    }
    /**
     * Set organisation_name value
     * @param string $organisation_name
     * @return \StructType\DutchBusinessUBOClassifiedRole
     */
    public function setOrganisation_name($organisation_name = null)
    {
        // validation for constraint: string
        if (!is_null($organisation_name) && !is_string($organisation_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($organisation_name, true), gettype($organisation_name)), __LINE__);
        }
        $this->organisation_name = $organisation_name;
        return $this;
    }
    /**
     * Get function_type value
     * @return string
     */
    public function getFunction_type()
    {
        return $this->function_type;
    }
    /**
     * Set function_type value
     * @param string $function_type
     * @return \StructType\DutchBusinessUBOClassifiedRole
     */
    public function setFunction_type($function_type = null)
    {
        // validation for constraint: string
        if (!is_null($function_type) && !is_string($function_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($function_type, true), gettype($function_type)), __LINE__);
        }
        $this->function_type = $function_type;
        return $this;
    }
    /**
     * Get title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * Set title value
     * @param string $title
     * @return \StructType\DutchBusinessUBOClassifiedRole
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->title = $title;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DutchBusinessUBOClassifiedRole
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
