<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRCompanyRelations StructType
 * @subpackage Structs
 */
class GCRCompanyRelations extends AbstractStructBase
{
    /**
     * The companies
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRCompanyArray
     */
    public $companies;
    /**
     * The persons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRPersonArray
     */
    public $persons;
    /**
     * Constructor method for GCRCompanyRelations
     * @uses GCRCompanyRelations::setCompanies()
     * @uses GCRCompanyRelations::setPersons()
     * @param \ArrayType\GCRCompanyArray $companies
     * @param \ArrayType\GCRPersonArray $persons
     */
    public function __construct(\ArrayType\GCRCompanyArray $companies = null, \ArrayType\GCRPersonArray $persons = null)
    {
        $this
            ->setCompanies($companies)
            ->setPersons($persons);
    }
    /**
     * Get companies value
     * @return \ArrayType\GCRCompanyArray|null
     */
    public function getCompanies()
    {
        return $this->companies;
    }
    /**
     * Set companies value
     * @param \ArrayType\GCRCompanyArray $companies
     * @return \StructType\GCRCompanyRelations
     */
    public function setCompanies(\ArrayType\GCRCompanyArray $companies = null)
    {
        $this->companies = $companies;
        return $this;
    }
    /**
     * Get persons value
     * @return \ArrayType\GCRPersonArray|null
     */
    public function getPersons()
    {
        return $this->persons;
    }
    /**
     * Set persons value
     * @param \ArrayType\GCRPersonArray $persons
     * @return \StructType\GCRCompanyRelations
     */
    public function setPersons(\ArrayType\GCRPersonArray $persons = null)
    {
        $this->persons = $persons;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GCRCompanyRelations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
