<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRPerson StructType
 * @subpackage Structs
 */
class GCRPerson extends AbstractStructBase
{
    /**
     * The graydon_person_id
     * @var int
     */
    public $graydon_person_id;
    /**
     * The personal_details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRPersonalDetails
     */
    public $personal_details;
    /**
     * The telephone_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRTelephoneNumber
     */
    public $telephone_number;
    /**
     * The address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRAddress
     */
    public $address;
    /**
     * The birth_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRBirthInformation
     */
    public $birth_information;
    /**
     * The job_titles
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRJobTitleArray
     */
    public $job_titles;
    /**
     * The financial_calamities
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRFinancialCalamityArray
     */
    public $financial_calamities;
    /**
     * Constructor method for GCRPerson
     * @uses GCRPerson::setGraydon_person_id()
     * @uses GCRPerson::setPersonal_details()
     * @uses GCRPerson::setTelephone_number()
     * @uses GCRPerson::setAddress()
     * @uses GCRPerson::setBirth_information()
     * @uses GCRPerson::setJob_titles()
     * @uses GCRPerson::setFinancial_calamities()
     * @param int $graydon_person_id
     * @param \StructType\GCRPersonalDetails $personal_details
     * @param \StructType\GCRTelephoneNumber $telephone_number
     * @param \StructType\GCRAddress $address
     * @param \StructType\GCRBirthInformation $birth_information
     * @param \ArrayType\GCRJobTitleArray $job_titles
     * @param \ArrayType\GCRFinancialCalamityArray $financial_calamities
     */
    public function __construct($graydon_person_id = null, \StructType\GCRPersonalDetails $personal_details = null, \StructType\GCRTelephoneNumber $telephone_number = null, \StructType\GCRAddress $address = null, \StructType\GCRBirthInformation $birth_information = null, \ArrayType\GCRJobTitleArray $job_titles = null, \ArrayType\GCRFinancialCalamityArray $financial_calamities = null)
    {
        $this
            ->setGraydon_person_id($graydon_person_id)
            ->setPersonal_details($personal_details)
            ->setTelephone_number($telephone_number)
            ->setAddress($address)
            ->setBirth_information($birth_information)
            ->setJob_titles($job_titles)
            ->setFinancial_calamities($financial_calamities);
    }
    /**
     * Get graydon_person_id value
     * @return int|null
     */
    public function getGraydon_person_id()
    {
        return $this->graydon_person_id;
    }
    /**
     * Set graydon_person_id value
     * @param int $graydon_person_id
     * @return \StructType\GCRPerson
     */
    public function setGraydon_person_id($graydon_person_id = null)
    {
        // validation for constraint: int
        if (!is_null($graydon_person_id) && !(is_int($graydon_person_id) || ctype_digit($graydon_person_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($graydon_person_id, true), gettype($graydon_person_id)), __LINE__);
        }
        $this->graydon_person_id = $graydon_person_id;
        return $this;
    }
    /**
     * Get personal_details value
     * @return \StructType\GCRPersonalDetails|null
     */
    public function getPersonal_details()
    {
        return $this->personal_details;
    }
    /**
     * Set personal_details value
     * @param \StructType\GCRPersonalDetails $personal_details
     * @return \StructType\GCRPerson
     */
    public function setPersonal_details(\StructType\GCRPersonalDetails $personal_details = null)
    {
        $this->personal_details = $personal_details;
        return $this;
    }
    /**
     * Get telephone_number value
     * @return \StructType\GCRTelephoneNumber|null
     */
    public function getTelephone_number()
    {
        return $this->telephone_number;
    }
    /**
     * Set telephone_number value
     * @param \StructType\GCRTelephoneNumber $telephone_number
     * @return \StructType\GCRPerson
     */
    public function setTelephone_number(\StructType\GCRTelephoneNumber $telephone_number = null)
    {
        $this->telephone_number = $telephone_number;
        return $this;
    }
    /**
     * Get address value
     * @return \StructType\GCRAddress|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param \StructType\GCRAddress $address
     * @return \StructType\GCRPerson
     */
    public function setAddress(\StructType\GCRAddress $address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get birth_information value
     * @return \StructType\GCRBirthInformation|null
     */
    public function getBirth_information()
    {
        return $this->birth_information;
    }
    /**
     * Set birth_information value
     * @param \StructType\GCRBirthInformation $birth_information
     * @return \StructType\GCRPerson
     */
    public function setBirth_information(\StructType\GCRBirthInformation $birth_information = null)
    {
        $this->birth_information = $birth_information;
        return $this;
    }
    /**
     * Get job_titles value
     * @return \ArrayType\GCRJobTitleArray|null
     */
    public function getJob_titles()
    {
        return $this->job_titles;
    }
    /**
     * Set job_titles value
     * @param \ArrayType\GCRJobTitleArray $job_titles
     * @return \StructType\GCRPerson
     */
    public function setJob_titles(\ArrayType\GCRJobTitleArray $job_titles = null)
    {
        $this->job_titles = $job_titles;
        return $this;
    }
    /**
     * Get financial_calamities value
     * @return \ArrayType\GCRFinancialCalamityArray|null
     */
    public function getFinancial_calamities()
    {
        return $this->financial_calamities;
    }
    /**
     * Set financial_calamities value
     * @param \ArrayType\GCRFinancialCalamityArray $financial_calamities
     * @return \StructType\GCRPerson
     */
    public function setFinancial_calamities(\ArrayType\GCRFinancialCalamityArray $financial_calamities = null)
    {
        $this->financial_calamities = $financial_calamities;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GCRPerson
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
