<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GraydonCreditReportManagement StructType
 * @subpackage Structs
 */
class GraydonCreditReportManagement extends AbstractStructBase
{
    /**
     * The company_management
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRCompanyManagement
     */
    public $company_management;
    /**
     * The persons
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRPersonArray
     */
    public $persons;
    /**
     * The alarm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRAlarm
     */
    public $alarm;
    /**
     * Constructor method for GraydonCreditReportManagement
     * @uses GraydonCreditReportManagement::setCompany_management()
     * @uses GraydonCreditReportManagement::setPersons()
     * @uses GraydonCreditReportManagement::setAlarm()
     * @param \StructType\GCRCompanyManagement $company_management
     * @param \ArrayType\GCRPersonArray $persons
     * @param \StructType\GCRAlarm $alarm
     */
    public function __construct(\StructType\GCRCompanyManagement $company_management = null, \ArrayType\GCRPersonArray $persons = null, \StructType\GCRAlarm $alarm = null)
    {
        $this
            ->setCompany_management($company_management)
            ->setPersons($persons)
            ->setAlarm($alarm);
    }
    /**
     * Get company_management value
     * @return \StructType\GCRCompanyManagement|null
     */
    public function getCompany_management()
    {
        return $this->company_management;
    }
    /**
     * Set company_management value
     * @param \StructType\GCRCompanyManagement $company_management
     * @return \StructType\GraydonCreditReportManagement
     */
    public function setCompany_management(\StructType\GCRCompanyManagement $company_management = null)
    {
        $this->company_management = $company_management;
        return $this;
    }
    /**
     * Get persons value
     * @return \ArrayType\GCRPersonArray|null
     */
    public function getPersons()
    {
        return $this->persons;
    }
    /**
     * Set persons value
     * @param \ArrayType\GCRPersonArray $persons
     * @return \StructType\GraydonCreditReportManagement
     */
    public function setPersons(\ArrayType\GCRPersonArray $persons = null)
    {
        $this->persons = $persons;
        return $this;
    }
    /**
     * Get alarm value
     * @return \StructType\GCRAlarm|null
     */
    public function getAlarm()
    {
        return $this->alarm;
    }
    /**
     * Set alarm value
     * @param \StructType\GCRAlarm $alarm
     * @return \StructType\GraydonCreditReportManagement
     */
    public function setAlarm(\StructType\GCRAlarm $alarm = null)
    {
        $this->alarm = $alarm;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GraydonCreditReportManagement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
