<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GraydonCreditReportNormal StructType
 * @subpackage Structs
 */
class GraydonCreditReportNormal extends AbstractStructBase
{
    /**
     * The company
     * @var \StructType\GCRCompanyItself
     */
    public $company;
    /**
     * The company_relations
     * @var \StructType\GCRCompanyRelations
     */
    public $company_relations;
    /**
     * The indirect_company_relations
     * @var \StructType\GCRCompanyRelations
     */
    public $indirect_company_relations;
    /**
     * Constructor method for GraydonCreditReportNormal
     * @uses GraydonCreditReportNormal::setCompany()
     * @uses GraydonCreditReportNormal::setCompany_relations()
     * @uses GraydonCreditReportNormal::setIndirect_company_relations()
     * @param \StructType\GCRCompanyItself $company
     * @param \StructType\GCRCompanyRelations $company_relations
     * @param \StructType\GCRCompanyRelations $indirect_company_relations
     */
    public function __construct(\StructType\GCRCompanyItself $company = null, \StructType\GCRCompanyRelations $company_relations = null, \StructType\GCRCompanyRelations $indirect_company_relations = null)
    {
        $this
            ->setCompany($company)
            ->setCompany_relations($company_relations)
            ->setIndirect_company_relations($indirect_company_relations);
    }
    /**
     * Get company value
     * @return \StructType\GCRCompanyItself|null
     */
    public function getCompany()
    {
        return $this->company;
    }
    /**
     * Set company value
     * @param \StructType\GCRCompanyItself $company
     * @return \StructType\GraydonCreditReportNormal
     */
    public function setCompany(\StructType\GCRCompanyItself $company = null)
    {
        $this->company = $company;
        return $this;
    }
    /**
     * Get company_relations value
     * @return \StructType\GCRCompanyRelations|null
     */
    public function getCompany_relations()
    {
        return $this->company_relations;
    }
    /**
     * Set company_relations value
     * @param \StructType\GCRCompanyRelations $company_relations
     * @return \StructType\GraydonCreditReportNormal
     */
    public function setCompany_relations(\StructType\GCRCompanyRelations $company_relations = null)
    {
        $this->company_relations = $company_relations;
        return $this;
    }
    /**
     * Get indirect_company_relations value
     * @return \StructType\GCRCompanyRelations|null
     */
    public function getIndirect_company_relations()
    {
        return $this->indirect_company_relations;
    }
    /**
     * Set indirect_company_relations value
     * @param \StructType\GCRCompanyRelations $indirect_company_relations
     * @return \StructType\GraydonCreditReportNormal
     */
    public function setIndirect_company_relations(\StructType\GCRCompanyRelations $indirect_company_relations = null)
    {
        $this->indirect_company_relations = $indirect_company_relations;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GraydonCreditReportNormal
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
