<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GraydonCreditReportRatings StructType
 * @subpackage Structs
 */
class GraydonCreditReportRatings extends AbstractStructBase
{
    /**
     * The credit_advice_amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $credit_advice_amount;
    /**
     * The credit_advice_currency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $credit_advice_currency;
    /**
     * The credit_advice_factors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRCreditFactorArray
     */
    public $credit_advice_factors;
    /**
     * The pd_rating
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pd_rating;
    /**
     * The ratings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRRatingArray
     */
    public $ratings;
    /**
     * The payment_information
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRPaymentInformationArray
     */
    public $payment_information;
    /**
     * The alarm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRAlarm
     */
    public $alarm;
    /**
     * Constructor method for GraydonCreditReportRatings
     * @uses GraydonCreditReportRatings::setCredit_advice_amount()
     * @uses GraydonCreditReportRatings::setCredit_advice_currency()
     * @uses GraydonCreditReportRatings::setCredit_advice_factors()
     * @uses GraydonCreditReportRatings::setPd_rating()
     * @uses GraydonCreditReportRatings::setRatings()
     * @uses GraydonCreditReportRatings::setPayment_information()
     * @uses GraydonCreditReportRatings::setAlarm()
     * @param string $credit_advice_amount
     * @param string $credit_advice_currency
     * @param \ArrayType\GCRCreditFactorArray $credit_advice_factors
     * @param string $pd_rating
     * @param \ArrayType\GCRRatingArray $ratings
     * @param \ArrayType\GCRPaymentInformationArray $payment_information
     * @param \StructType\GCRAlarm $alarm
     */
    public function __construct($credit_advice_amount = null, $credit_advice_currency = null, \ArrayType\GCRCreditFactorArray $credit_advice_factors = null, $pd_rating = null, \ArrayType\GCRRatingArray $ratings = null, \ArrayType\GCRPaymentInformationArray $payment_information = null, \StructType\GCRAlarm $alarm = null)
    {
        $this
            ->setCredit_advice_amount($credit_advice_amount)
            ->setCredit_advice_currency($credit_advice_currency)
            ->setCredit_advice_factors($credit_advice_factors)
            ->setPd_rating($pd_rating)
            ->setRatings($ratings)
            ->setPayment_information($payment_information)
            ->setAlarm($alarm);
    }
    /**
     * Get credit_advice_amount value
     * @return string|null
     */
    public function getCredit_advice_amount()
    {
        return $this->credit_advice_amount;
    }
    /**
     * Set credit_advice_amount value
     * @param string $credit_advice_amount
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setCredit_advice_amount($credit_advice_amount = null)
    {
        // validation for constraint: string
        if (!is_null($credit_advice_amount) && !is_string($credit_advice_amount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($credit_advice_amount, true), gettype($credit_advice_amount)), __LINE__);
        }
        $this->credit_advice_amount = $credit_advice_amount;
        return $this;
    }
    /**
     * Get credit_advice_currency value
     * @return string|null
     */
    public function getCredit_advice_currency()
    {
        return $this->credit_advice_currency;
    }
    /**
     * Set credit_advice_currency value
     * @param string $credit_advice_currency
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setCredit_advice_currency($credit_advice_currency = null)
    {
        // validation for constraint: string
        if (!is_null($credit_advice_currency) && !is_string($credit_advice_currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($credit_advice_currency, true), gettype($credit_advice_currency)), __LINE__);
        }
        $this->credit_advice_currency = $credit_advice_currency;
        return $this;
    }
    /**
     * Get credit_advice_factors value
     * @return \ArrayType\GCRCreditFactorArray|null
     */
    public function getCredit_advice_factors()
    {
        return $this->credit_advice_factors;
    }
    /**
     * Set credit_advice_factors value
     * @param \ArrayType\GCRCreditFactorArray $credit_advice_factors
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setCredit_advice_factors(\ArrayType\GCRCreditFactorArray $credit_advice_factors = null)
    {
        $this->credit_advice_factors = $credit_advice_factors;
        return $this;
    }
    /**
     * Get pd_rating value
     * @return string|null
     */
    public function getPd_rating()
    {
        return $this->pd_rating;
    }
    /**
     * Set pd_rating value
     * @param string $pd_rating
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setPd_rating($pd_rating = null)
    {
        // validation for constraint: string
        if (!is_null($pd_rating) && !is_string($pd_rating)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pd_rating, true), gettype($pd_rating)), __LINE__);
        }
        $this->pd_rating = $pd_rating;
        return $this;
    }
    /**
     * Get ratings value
     * @return \ArrayType\GCRRatingArray|null
     */
    public function getRatings()
    {
        return $this->ratings;
    }
    /**
     * Set ratings value
     * @param \ArrayType\GCRRatingArray $ratings
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setRatings(\ArrayType\GCRRatingArray $ratings = null)
    {
        $this->ratings = $ratings;
        return $this;
    }
    /**
     * Get payment_information value
     * @return \ArrayType\GCRPaymentInformationArray|null
     */
    public function getPayment_information()
    {
        return $this->payment_information;
    }
    /**
     * Set payment_information value
     * @param \ArrayType\GCRPaymentInformationArray $payment_information
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setPayment_information(\ArrayType\GCRPaymentInformationArray $payment_information = null)
    {
        $this->payment_information = $payment_information;
        return $this;
    }
    /**
     * Get alarm value
     * @return \StructType\GCRAlarm|null
     */
    public function getAlarm()
    {
        return $this->alarm;
    }
    /**
     * Set alarm value
     * @param \StructType\GCRAlarm $alarm
     * @return \StructType\GraydonCreditReportRatings
     */
    public function setAlarm(\StructType\GCRAlarm $alarm = null)
    {
        $this->alarm = $alarm;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GraydonCreditReportRatings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
