<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kadasterHypotheek StructType
 * @subpackage Structs
 */
class KadasterHypotheek extends AbstractStructBase
{
    /**
     * The hoofdsom
     * @var \StructType\KadasterBedrag
     */
    public $hoofdsom;
    /**
     * The rentevoet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $rentevoet;
    /**
     * The meerdere_rentevoet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $meerdere_rentevoet;
    /**
     * Constructor method for kadasterHypotheek
     * @uses KadasterHypotheek::setHoofdsom()
     * @uses KadasterHypotheek::setRentevoet()
     * @uses KadasterHypotheek::setMeerdere_rentevoet()
     * @param \StructType\KadasterBedrag $hoofdsom
     * @param float $rentevoet
     * @param bool $meerdere_rentevoet
     */
    public function __construct(\StructType\KadasterBedrag $hoofdsom = null, $rentevoet = null, $meerdere_rentevoet = null)
    {
        $this
            ->setHoofdsom($hoofdsom)
            ->setRentevoet($rentevoet)
            ->setMeerdere_rentevoet($meerdere_rentevoet);
    }
    /**
     * Get hoofdsom value
     * @return \StructType\KadasterBedrag|null
     */
    public function getHoofdsom()
    {
        return $this->hoofdsom;
    }
    /**
     * Set hoofdsom value
     * @param \StructType\KadasterBedrag $hoofdsom
     * @return \StructType\KadasterHypotheek
     */
    public function setHoofdsom(\StructType\KadasterBedrag $hoofdsom = null)
    {
        $this->hoofdsom = $hoofdsom;
        return $this;
    }
    /**
     * Get rentevoet value
     * @return float|null
     */
    public function getRentevoet()
    {
        return $this->rentevoet;
    }
    /**
     * Set rentevoet value
     * @param float $rentevoet
     * @return \StructType\KadasterHypotheek
     */
    public function setRentevoet($rentevoet = null)
    {
        // validation for constraint: float
        if (!is_null($rentevoet) && !(is_float($rentevoet) || is_numeric($rentevoet))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($rentevoet, true), gettype($rentevoet)), __LINE__);
        }
        $this->rentevoet = $rentevoet;
        return $this;
    }
    /**
     * Get meerdere_rentevoet value
     * @return bool|null
     */
    public function getMeerdere_rentevoet()
    {
        return $this->meerdere_rentevoet;
    }
    /**
     * Set meerdere_rentevoet value
     * @param bool $meerdere_rentevoet
     * @return \StructType\KadasterHypotheek
     */
    public function setMeerdere_rentevoet($meerdere_rentevoet = null)
    {
        // validation for constraint: boolean
        if (!is_null($meerdere_rentevoet) && !is_bool($meerdere_rentevoet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($meerdere_rentevoet, true), gettype($meerdere_rentevoet)), __LINE__);
        }
        $this->meerdere_rentevoet = $meerdere_rentevoet;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterHypotheek
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
