<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kadasterStukdeel StructType
 * @subpackage Structs
 */
class KadasterStukdeel extends AbstractStructBase
{
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * The aard_stukdeel_omschrijving
     * @var string
     */
    public $aard_stukdeel_omschrijving;
    /**
     * The hypotheek
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterHypotheek
     */
    public $hypotheek;
    /**
     * The schuldeisers_beslagleggers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterPersoonLijst
     */
    public $schuldeisers_beslagleggers;
    /**
     * The vordering
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterBedrag
     */
    public $vordering;
    /**
     * The rechten
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterStukdeelRechtArray
     */
    public $rechten;
    /**
     * The onroerende_zaken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterBeknoptOnroerendeZaakArray
     */
    public $onroerende_zaken;
    /**
     * The omschrijving
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $omschrijving;
    /**
     * The stukdeel_relaties
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterStukdeelReferentiesLijst
     */
    public $stukdeel_relaties;
    /**
     * The hoort_bij
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterGerelateerdStukdeelArray
     */
    public $hoort_bij;
    /**
     * Constructor method for kadasterStukdeel
     * @uses KadasterStukdeel::setId()
     * @uses KadasterStukdeel::setAard_stukdeel_omschrijving()
     * @uses KadasterStukdeel::setHypotheek()
     * @uses KadasterStukdeel::setSchuldeisers_beslagleggers()
     * @uses KadasterStukdeel::setVordering()
     * @uses KadasterStukdeel::setRechten()
     * @uses KadasterStukdeel::setOnroerende_zaken()
     * @uses KadasterStukdeel::setOmschrijving()
     * @uses KadasterStukdeel::setStukdeel_relaties()
     * @uses KadasterStukdeel::setHoort_bij()
     * @param string $id
     * @param string $aard_stukdeel_omschrijving
     * @param \StructType\KadasterHypotheek $hypotheek
     * @param \StructType\KadasterPersoonLijst $schuldeisers_beslagleggers
     * @param \StructType\KadasterBedrag $vordering
     * @param \ArrayType\KadasterStukdeelRechtArray $rechten
     * @param \ArrayType\KadasterBeknoptOnroerendeZaakArray $onroerende_zaken
     * @param string $omschrijving
     * @param \StructType\KadasterStukdeelReferentiesLijst $stukdeel_relaties
     * @param \ArrayType\KadasterGerelateerdStukdeelArray $hoort_bij
     */
    public function __construct($id = null, $aard_stukdeel_omschrijving = null, \StructType\KadasterHypotheek $hypotheek = null, \StructType\KadasterPersoonLijst $schuldeisers_beslagleggers = null, \StructType\KadasterBedrag $vordering = null, \ArrayType\KadasterStukdeelRechtArray $rechten = null, \ArrayType\KadasterBeknoptOnroerendeZaakArray $onroerende_zaken = null, $omschrijving = null, \StructType\KadasterStukdeelReferentiesLijst $stukdeel_relaties = null, \ArrayType\KadasterGerelateerdStukdeelArray $hoort_bij = null)
    {
        $this
            ->setId($id)
            ->setAard_stukdeel_omschrijving($aard_stukdeel_omschrijving)
            ->setHypotheek($hypotheek)
            ->setSchuldeisers_beslagleggers($schuldeisers_beslagleggers)
            ->setVordering($vordering)
            ->setRechten($rechten)
            ->setOnroerende_zaken($onroerende_zaken)
            ->setOmschrijving($omschrijving)
            ->setStukdeel_relaties($stukdeel_relaties)
            ->setHoort_bij($hoort_bij);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\KadasterStukdeel
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get aard_stukdeel_omschrijving value
     * @return string|null
     */
    public function getAard_stukdeel_omschrijving()
    {
        return $this->aard_stukdeel_omschrijving;
    }
    /**
     * Set aard_stukdeel_omschrijving value
     * @param string $aard_stukdeel_omschrijving
     * @return \StructType\KadasterStukdeel
     */
    public function setAard_stukdeel_omschrijving($aard_stukdeel_omschrijving = null)
    {
        // validation for constraint: string
        if (!is_null($aard_stukdeel_omschrijving) && !is_string($aard_stukdeel_omschrijving)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aard_stukdeel_omschrijving, true), gettype($aard_stukdeel_omschrijving)), __LINE__);
        }
        $this->aard_stukdeel_omschrijving = $aard_stukdeel_omschrijving;
        return $this;
    }
    /**
     * Get hypotheek value
     * @return \StructType\KadasterHypotheek|null
     */
    public function getHypotheek()
    {
        return $this->hypotheek;
    }
    /**
     * Set hypotheek value
     * @param \StructType\KadasterHypotheek $hypotheek
     * @return \StructType\KadasterStukdeel
     */
    public function setHypotheek(\StructType\KadasterHypotheek $hypotheek = null)
    {
        $this->hypotheek = $hypotheek;
        return $this;
    }
    /**
     * Get schuldeisers_beslagleggers value
     * @return \StructType\KadasterPersoonLijst|null
     */
    public function getSchuldeisers_beslagleggers()
    {
        return $this->schuldeisers_beslagleggers;
    }
    /**
     * Set schuldeisers_beslagleggers value
     * @param \StructType\KadasterPersoonLijst $schuldeisers_beslagleggers
     * @return \StructType\KadasterStukdeel
     */
    public function setSchuldeisers_beslagleggers(\StructType\KadasterPersoonLijst $schuldeisers_beslagleggers = null)
    {
        $this->schuldeisers_beslagleggers = $schuldeisers_beslagleggers;
        return $this;
    }
    /**
     * Get vordering value
     * @return \StructType\KadasterBedrag|null
     */
    public function getVordering()
    {
        return $this->vordering;
    }
    /**
     * Set vordering value
     * @param \StructType\KadasterBedrag $vordering
     * @return \StructType\KadasterStukdeel
     */
    public function setVordering(\StructType\KadasterBedrag $vordering = null)
    {
        $this->vordering = $vordering;
        return $this;
    }
    /**
     * Get rechten value
     * @return \ArrayType\KadasterStukdeelRechtArray|null
     */
    public function getRechten()
    {
        return $this->rechten;
    }
    /**
     * Set rechten value
     * @param \ArrayType\KadasterStukdeelRechtArray $rechten
     * @return \StructType\KadasterStukdeel
     */
    public function setRechten(\ArrayType\KadasterStukdeelRechtArray $rechten = null)
    {
        $this->rechten = $rechten;
        return $this;
    }
    /**
     * Get onroerende_zaken value
     * @return \ArrayType\KadasterBeknoptOnroerendeZaakArray|null
     */
    public function getOnroerende_zaken()
    {
        return $this->onroerende_zaken;
    }
    /**
     * Set onroerende_zaken value
     * @param \ArrayType\KadasterBeknoptOnroerendeZaakArray $onroerende_zaken
     * @return \StructType\KadasterStukdeel
     */
    public function setOnroerende_zaken(\ArrayType\KadasterBeknoptOnroerendeZaakArray $onroerende_zaken = null)
    {
        $this->onroerende_zaken = $onroerende_zaken;
        return $this;
    }
    /**
     * Get omschrijving value
     * @return string|null
     */
    public function getOmschrijving()
    {
        return $this->omschrijving;
    }
    /**
     * Set omschrijving value
     * @param string $omschrijving
     * @return \StructType\KadasterStukdeel
     */
    public function setOmschrijving($omschrijving = null)
    {
        // validation for constraint: string
        if (!is_null($omschrijving) && !is_string($omschrijving)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($omschrijving, true), gettype($omschrijving)), __LINE__);
        }
        $this->omschrijving = $omschrijving;
        return $this;
    }
    /**
     * Get stukdeel_relaties value
     * @return \StructType\KadasterStukdeelReferentiesLijst|null
     */
    public function getStukdeel_relaties()
    {
        return $this->stukdeel_relaties;
    }
    /**
     * Set stukdeel_relaties value
     * @param \StructType\KadasterStukdeelReferentiesLijst $stukdeel_relaties
     * @return \StructType\KadasterStukdeel
     */
    public function setStukdeel_relaties(\StructType\KadasterStukdeelReferentiesLijst $stukdeel_relaties = null)
    {
        $this->stukdeel_relaties = $stukdeel_relaties;
        return $this;
    }
    /**
     * Get hoort_bij value
     * @return \ArrayType\KadasterGerelateerdStukdeelArray|null
     */
    public function getHoort_bij()
    {
        return $this->hoort_bij;
    }
    /**
     * Set hoort_bij value
     * @param \ArrayType\KadasterGerelateerdStukdeelArray $hoort_bij
     * @return \StructType\KadasterStukdeel
     */
    public function setHoort_bij(\ArrayType\KadasterGerelateerdStukdeelArray $hoort_bij = null)
    {
        $this->hoort_bij = $hoort_bij;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterStukdeel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
