<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2AcgIdentificatie StructType
 * @subpackage Structs
 */
class KadasterV2AcgIdentificatie extends AbstractStructBase
{
    /**
     * The akr_registercode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $akr_registercode;
    /**
     * The akr_stukdelen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $akr_stukdelen;
    /**
     * The volgnummer_staat75
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $volgnummer_staat75;
    /**
     * Constructor method for KadasterV2AcgIdentificatie
     * @uses KadasterV2AcgIdentificatie::setAkr_registercode()
     * @uses KadasterV2AcgIdentificatie::setAkr_stukdelen()
     * @uses KadasterV2AcgIdentificatie::setVolgnummer_staat75()
     * @param string $akr_registercode
     * @param \ArrayType\StringArray $akr_stukdelen
     * @param int $volgnummer_staat75
     */
    public function __construct($akr_registercode = null, \ArrayType\StringArray $akr_stukdelen = null, $volgnummer_staat75 = null)
    {
        $this
            ->setAkr_registercode($akr_registercode)
            ->setAkr_stukdelen($akr_stukdelen)
            ->setVolgnummer_staat75($volgnummer_staat75);
    }
    /**
     * Get akr_registercode value
     * @return string|null
     */
    public function getAkr_registercode()
    {
        return $this->akr_registercode;
    }
    /**
     * Set akr_registercode value
     * @param string $akr_registercode
     * @return \StructType\KadasterV2AcgIdentificatie
     */
    public function setAkr_registercode($akr_registercode = null)
    {
        // validation for constraint: string
        if (!is_null($akr_registercode) && !is_string($akr_registercode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($akr_registercode, true), gettype($akr_registercode)), __LINE__);
        }
        $this->akr_registercode = $akr_registercode;
        return $this;
    }
    /**
     * Get akr_stukdelen value
     * @return \ArrayType\StringArray|null
     */
    public function getAkr_stukdelen()
    {
        return $this->akr_stukdelen;
    }
    /**
     * Set akr_stukdelen value
     * @param \ArrayType\StringArray $akr_stukdelen
     * @return \StructType\KadasterV2AcgIdentificatie
     */
    public function setAkr_stukdelen(\ArrayType\StringArray $akr_stukdelen = null)
    {
        $this->akr_stukdelen = $akr_stukdelen;
        return $this;
    }
    /**
     * Get volgnummer_staat75 value
     * @return int|null
     */
    public function getVolgnummer_staat75()
    {
        return $this->volgnummer_staat75;
    }
    /**
     * Set volgnummer_staat75 value
     * @param int $volgnummer_staat75
     * @return \StructType\KadasterV2AcgIdentificatie
     */
    public function setVolgnummer_staat75($volgnummer_staat75 = null)
    {
        // validation for constraint: int
        if (!is_null($volgnummer_staat75) && !(is_int($volgnummer_staat75) || ctype_digit($volgnummer_staat75))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($volgnummer_staat75, true), gettype($volgnummer_staat75)), __LINE__);
        }
        $this->volgnummer_staat75 = $volgnummer_staat75;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2AcgIdentificatie
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
