<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2ErfpachtCanon StructType
 * @subpackage Structs
 */
class KadasterV2ErfpachtCanon extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $identificatie;
    /**
     * The soort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $soort;
    /**
     * The einddatum_afkoop
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $einddatum_afkoop;
    /**
     * The indicatie_oude_onroerende_zaak_betrokken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $indicatie_oude_onroerende_zaak_betrokken;
    /**
     * The jaarlijks_bedrag
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2JaarlijksBedrag
     */
    public $jaarlijks_bedrag;
    /**
     * The betreft
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2ZakelijkRecht
     */
    public $betreft;
    /**
     * The gebaseerd_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Stukdeel
     */
    public $gebaseerd_op;
    /**
     * The vermeld_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $vermeld_in;
    /**
     * Constructor method for KadasterV2ErfpachtCanon
     * @uses KadasterV2ErfpachtCanon::setIdentificatie()
     * @uses KadasterV2ErfpachtCanon::setSoort()
     * @uses KadasterV2ErfpachtCanon::setEinddatum_afkoop()
     * @uses KadasterV2ErfpachtCanon::setIndicatie_oude_onroerende_zaak_betrokken()
     * @uses KadasterV2ErfpachtCanon::setJaarlijks_bedrag()
     * @uses KadasterV2ErfpachtCanon::setBetreft()
     * @uses KadasterV2ErfpachtCanon::setGebaseerd_op()
     * @uses KadasterV2ErfpachtCanon::setVermeld_in()
     * @param string $identificatie
     * @param string $soort
     * @param string $einddatum_afkoop
     * @param bool $indicatie_oude_onroerende_zaak_betrokken
     * @param \StructType\KadasterV2JaarlijksBedrag $jaarlijks_bedrag
     * @param \StructType\KadasterV2ZakelijkRecht $betreft
     * @param \StructType\KadasterV2Stukdeel $gebaseerd_op
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     */
    public function __construct($identificatie = null, $soort = null, $einddatum_afkoop = null, $indicatie_oude_onroerende_zaak_betrokken = null, \StructType\KadasterV2JaarlijksBedrag $jaarlijks_bedrag = null, \StructType\KadasterV2ZakelijkRecht $betreft = null, \StructType\KadasterV2Stukdeel $gebaseerd_op = null, \ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setSoort($soort)
            ->setEinddatum_afkoop($einddatum_afkoop)
            ->setIndicatie_oude_onroerende_zaak_betrokken($indicatie_oude_onroerende_zaak_betrokken)
            ->setJaarlijks_bedrag($jaarlijks_bedrag)
            ->setBetreft($betreft)
            ->setGebaseerd_op($gebaseerd_op)
            ->setVermeld_in($vermeld_in);
    }
    /**
     * Get identificatie value
     * @return string
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get soort value
     * @return string|null
     */
    public function getSoort()
    {
        return $this->soort;
    }
    /**
     * Set soort value
     * @param string $soort
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setSoort($soort = null)
    {
        // validation for constraint: string
        if (!is_null($soort) && !is_string($soort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($soort, true), gettype($soort)), __LINE__);
        }
        $this->soort = $soort;
        return $this;
    }
    /**
     * Get einddatum_afkoop value
     * @return string|null
     */
    public function getEinddatum_afkoop()
    {
        return $this->einddatum_afkoop;
    }
    /**
     * Set einddatum_afkoop value
     * @param string $einddatum_afkoop
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setEinddatum_afkoop($einddatum_afkoop = null)
    {
        // validation for constraint: string
        if (!is_null($einddatum_afkoop) && !is_string($einddatum_afkoop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($einddatum_afkoop, true), gettype($einddatum_afkoop)), __LINE__);
        }
        $this->einddatum_afkoop = $einddatum_afkoop;
        return $this;
    }
    /**
     * Get indicatie_oude_onroerende_zaak_betrokken value
     * @return bool|null
     */
    public function getIndicatie_oude_onroerende_zaak_betrokken()
    {
        return $this->indicatie_oude_onroerende_zaak_betrokken;
    }
    /**
     * Set indicatie_oude_onroerende_zaak_betrokken value
     * @param bool $indicatie_oude_onroerende_zaak_betrokken
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setIndicatie_oude_onroerende_zaak_betrokken($indicatie_oude_onroerende_zaak_betrokken = null)
    {
        // validation for constraint: boolean
        if (!is_null($indicatie_oude_onroerende_zaak_betrokken) && !is_bool($indicatie_oude_onroerende_zaak_betrokken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($indicatie_oude_onroerende_zaak_betrokken, true), gettype($indicatie_oude_onroerende_zaak_betrokken)), __LINE__);
        }
        $this->indicatie_oude_onroerende_zaak_betrokken = $indicatie_oude_onroerende_zaak_betrokken;
        return $this;
    }
    /**
     * Get jaarlijks_bedrag value
     * @return \StructType\KadasterV2JaarlijksBedrag|null
     */
    public function getJaarlijks_bedrag()
    {
        return $this->jaarlijks_bedrag;
    }
    /**
     * Set jaarlijks_bedrag value
     * @param \StructType\KadasterV2JaarlijksBedrag $jaarlijks_bedrag
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setJaarlijks_bedrag(\StructType\KadasterV2JaarlijksBedrag $jaarlijks_bedrag = null)
    {
        $this->jaarlijks_bedrag = $jaarlijks_bedrag;
        return $this;
    }
    /**
     * Get betreft value
     * @return \StructType\KadasterV2ZakelijkRecht|null
     */
    public function getBetreft()
    {
        return $this->betreft;
    }
    /**
     * Set betreft value
     * @param \StructType\KadasterV2ZakelijkRecht $betreft
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setBetreft(\StructType\KadasterV2ZakelijkRecht $betreft = null)
    {
        $this->betreft = $betreft;
        return $this;
    }
    /**
     * Get gebaseerd_op value
     * @return \StructType\KadasterV2Stukdeel|null
     */
    public function getGebaseerd_op()
    {
        return $this->gebaseerd_op;
    }
    /**
     * Set gebaseerd_op value
     * @param \StructType\KadasterV2Stukdeel $gebaseerd_op
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setGebaseerd_op(\StructType\KadasterV2Stukdeel $gebaseerd_op = null)
    {
        $this->gebaseerd_op = $gebaseerd_op;
        return $this;
    }
    /**
     * Get vermeld_in value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getVermeld_in()
    {
        return $this->vermeld_in;
    }
    /**
     * Set vermeld_in value
     * @param \ArrayType\KadasterV2StukdeelArray $vermeld_in
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public function setVermeld_in(\ArrayType\KadasterV2StukdeelArray $vermeld_in = null)
    {
        $this->vermeld_in = $vermeld_in;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2ErfpachtCanon
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
