<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2HypothecairBerichtResponse StructType
 * @subpackage Structs
 */
class KadasterV2HypothecairBerichtResponse extends AbstractStructBase
{
    /**
     * The bericht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2HypothecairBericht
     */
    public $bericht;
    /**
     * The document
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $document;
    /**
     * The overgegaan_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2OvergegaanIn
     */
    public $overgegaan_in;
    /**
     * The postcode_treffers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2PostcodeTreffers
     */
    public $postcode_treffers;
    /**
     * Constructor method for KadasterV2HypothecairBerichtResponse
     * @uses KadasterV2HypothecairBerichtResponse::setBericht()
     * @uses KadasterV2HypothecairBerichtResponse::setDocument()
     * @uses KadasterV2HypothecairBerichtResponse::setOvergegaan_in()
     * @uses KadasterV2HypothecairBerichtResponse::setPostcode_treffers()
     * @param \StructType\KadasterV2HypothecairBericht $bericht
     * @param string $document
     * @param \StructType\KadasterV2OvergegaanIn $overgegaan_in
     * @param \StructType\KadasterV2PostcodeTreffers $postcode_treffers
     */
    public function __construct(\StructType\KadasterV2HypothecairBericht $bericht = null, $document = null, \StructType\KadasterV2OvergegaanIn $overgegaan_in = null, \StructType\KadasterV2PostcodeTreffers $postcode_treffers = null)
    {
        $this
            ->setBericht($bericht)
            ->setDocument($document)
            ->setOvergegaan_in($overgegaan_in)
            ->setPostcode_treffers($postcode_treffers);
    }
    /**
     * Get bericht value
     * @return \StructType\KadasterV2HypothecairBericht|null
     */
    public function getBericht()
    {
        return $this->bericht;
    }
    /**
     * Set bericht value
     * @param \StructType\KadasterV2HypothecairBericht $bericht
     * @return \StructType\KadasterV2HypothecairBerichtResponse
     */
    public function setBericht(\StructType\KadasterV2HypothecairBericht $bericht = null)
    {
        $this->bericht = $bericht;
        return $this;
    }
    /**
     * Get document value
     * @return string|null
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\KadasterV2HypothecairBerichtResponse
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
    /**
     * Get overgegaan_in value
     * @return \StructType\KadasterV2OvergegaanIn|null
     */
    public function getOvergegaan_in()
    {
        return $this->overgegaan_in;
    }
    /**
     * Set overgegaan_in value
     * @param \StructType\KadasterV2OvergegaanIn $overgegaan_in
     * @return \StructType\KadasterV2HypothecairBerichtResponse
     */
    public function setOvergegaan_in(\StructType\KadasterV2OvergegaanIn $overgegaan_in = null)
    {
        $this->overgegaan_in = $overgegaan_in;
        return $this;
    }
    /**
     * Get postcode_treffers value
     * @return \StructType\KadasterV2PostcodeTreffers|null
     */
    public function getPostcode_treffers()
    {
        return $this->postcode_treffers;
    }
    /**
     * Set postcode_treffers value
     * @param \StructType\KadasterV2PostcodeTreffers $postcode_treffers
     * @return \StructType\KadasterV2HypothecairBerichtResponse
     */
    public function setPostcode_treffers(\StructType\KadasterV2PostcodeTreffers $postcode_treffers = null)
    {
        $this->postcode_treffers = $postcode_treffers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2HypothecairBerichtResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
