<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Mandeligheid StructType
 * @subpackage Structs
 */
class KadasterV2Mandeligheid extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The hoort_bij
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2HoofdzaakArray
     */
    public $hoort_bij;
    /**
     * The gebaseerd_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $gebaseerd_op;
    /**
     * Constructor method for KadasterV2Mandeligheid
     * @uses KadasterV2Mandeligheid::setIdentificatie()
     * @uses KadasterV2Mandeligheid::setHoort_bij()
     * @uses KadasterV2Mandeligheid::setGebaseerd_op()
     * @param string $identificatie
     * @param \ArrayType\KadasterV2HoofdzaakArray $hoort_bij
     * @param \ArrayType\KadasterV2StukdeelArray $gebaseerd_op
     */
    public function __construct($identificatie = null, \ArrayType\KadasterV2HoofdzaakArray $hoort_bij = null, \ArrayType\KadasterV2StukdeelArray $gebaseerd_op = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setHoort_bij($hoort_bij)
            ->setGebaseerd_op($gebaseerd_op);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Mandeligheid
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get hoort_bij value
     * @return \ArrayType\KadasterV2HoofdzaakArray|null
     */
    public function getHoort_bij()
    {
        return $this->hoort_bij;
    }
    /**
     * Set hoort_bij value
     * @param \ArrayType\KadasterV2HoofdzaakArray $hoort_bij
     * @return \StructType\KadasterV2Mandeligheid
     */
    public function setHoort_bij(\ArrayType\KadasterV2HoofdzaakArray $hoort_bij = null)
    {
        $this->hoort_bij = $hoort_bij;
        return $this;
    }
    /**
     * Get gebaseerd_op value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getGebaseerd_op()
    {
        return $this->gebaseerd_op;
    }
    /**
     * Set gebaseerd_op value
     * @param \ArrayType\KadasterV2StukdeelArray $gebaseerd_op
     * @return \StructType\KadasterV2Mandeligheid
     */
    public function setGebaseerd_op(\ArrayType\KadasterV2StukdeelArray $gebaseerd_op = null)
    {
        $this->gebaseerd_op = $gebaseerd_op;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2Mandeligheid
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
