<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2OnroerendeZaakReference StructType
 * @subpackage Structs
 */
class KadasterV2OnroerendeZaakReference extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The kadastrale_aanduiding
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2KadastraleAanduiding
     */
    public $kadastrale_aanduiding;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * Constructor method for KadasterV2OnroerendeZaakReference
     * @uses KadasterV2OnroerendeZaakReference::setIdentificatie()
     * @uses KadasterV2OnroerendeZaakReference::setKadastrale_aanduiding()
     * @uses KadasterV2OnroerendeZaakReference::setType()
     * @param string $identificatie
     * @param \StructType\KadasterV2KadastraleAanduiding $kadastrale_aanduiding
     * @param string $type
     */
    public function __construct($identificatie = null, \StructType\KadasterV2KadastraleAanduiding $kadastrale_aanduiding = null, $type = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setKadastrale_aanduiding($kadastrale_aanduiding)
            ->setType($type);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2OnroerendeZaakReference
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get kadastrale_aanduiding value
     * @return \StructType\KadasterV2KadastraleAanduiding|null
     */
    public function getKadastrale_aanduiding()
    {
        return $this->kadastrale_aanduiding;
    }
    /**
     * Set kadastrale_aanduiding value
     * @param \StructType\KadasterV2KadastraleAanduiding $kadastrale_aanduiding
     * @return \StructType\KadasterV2OnroerendeZaakReference
     */
    public function setKadastrale_aanduiding(\StructType\KadasterV2KadastraleAanduiding $kadastrale_aanduiding = null)
    {
        $this->kadastrale_aanduiding = $kadastrale_aanduiding;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\KadasterV2OnroerendeZaakReference
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2OnroerendeZaakReference
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
