<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2PostcodeTreffers StructType
 * @subpackage Structs
 */
class KadasterV2PostcodeTreffers extends AbstractStructBase
{
    /**
     * The productienummer
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $productienummer;
    /**
     * The tijdstip_samenstelling_bericht
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $tijdstip_samenstelling_bericht;
    /**
     * The betreft
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\KadasterV2GevraagdGebied
     */
    public $betreft;
    /**
     * The actualiteit_tijdstip_hypothecair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteit_tijdstip_hypothecair;
    /**
     * The actualiteit_tijdstip_kadastraal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteit_tijdstip_kadastraal;
    /**
     * The signalering_tijdstip_beslagen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_beslagen;
    /**
     * The signalering_tijdstip_hypothecair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_hypothecair;
    /**
     * The signalering_tijdstip_kadastraal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_kadastraal;
    /**
     * Constructor method for KadasterV2PostcodeTreffers
     * @uses KadasterV2PostcodeTreffers::setProductienummer()
     * @uses KadasterV2PostcodeTreffers::setTijdstip_samenstelling_bericht()
     * @uses KadasterV2PostcodeTreffers::setBetreft()
     * @uses KadasterV2PostcodeTreffers::setActualiteit_tijdstip_hypothecair()
     * @uses KadasterV2PostcodeTreffers::setActualiteit_tijdstip_kadastraal()
     * @uses KadasterV2PostcodeTreffers::setSignalering_tijdstip_beslagen()
     * @uses KadasterV2PostcodeTreffers::setSignalering_tijdstip_hypothecair()
     * @uses KadasterV2PostcodeTreffers::setSignalering_tijdstip_kadastraal()
     * @param string $productienummer
     * @param string $tijdstip_samenstelling_bericht
     * @param \StructType\KadasterV2GevraagdGebied $betreft
     * @param string $actualiteit_tijdstip_hypothecair
     * @param string $actualiteit_tijdstip_kadastraal
     * @param string $signalering_tijdstip_beslagen
     * @param string $signalering_tijdstip_hypothecair
     * @param string $signalering_tijdstip_kadastraal
     */
    public function __construct($productienummer = null, $tijdstip_samenstelling_bericht = null, \StructType\KadasterV2GevraagdGebied $betreft = null, $actualiteit_tijdstip_hypothecair = null, $actualiteit_tijdstip_kadastraal = null, $signalering_tijdstip_beslagen = null, $signalering_tijdstip_hypothecair = null, $signalering_tijdstip_kadastraal = null)
    {
        $this
            ->setProductienummer($productienummer)
            ->setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht)
            ->setBetreft($betreft)
            ->setActualiteit_tijdstip_hypothecair($actualiteit_tijdstip_hypothecair)
            ->setActualiteit_tijdstip_kadastraal($actualiteit_tijdstip_kadastraal)
            ->setSignalering_tijdstip_beslagen($signalering_tijdstip_beslagen)
            ->setSignalering_tijdstip_hypothecair($signalering_tijdstip_hypothecair)
            ->setSignalering_tijdstip_kadastraal($signalering_tijdstip_kadastraal);
    }
    /**
     * Get productienummer value
     * @return string
     */
    public function getProductienummer()
    {
        return $this->productienummer;
    }
    /**
     * Set productienummer value
     * @param string $productienummer
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setProductienummer($productienummer = null)
    {
        // validation for constraint: string
        if (!is_null($productienummer) && !is_string($productienummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productienummer, true), gettype($productienummer)), __LINE__);
        }
        $this->productienummer = $productienummer;
        return $this;
    }
    /**
     * Get tijdstip_samenstelling_bericht value
     * @return string
     */
    public function getTijdstip_samenstelling_bericht()
    {
        return $this->tijdstip_samenstelling_bericht;
    }
    /**
     * Set tijdstip_samenstelling_bericht value
     * @param string $tijdstip_samenstelling_bericht
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht = null)
    {
        // validation for constraint: string
        if (!is_null($tijdstip_samenstelling_bericht) && !is_string($tijdstip_samenstelling_bericht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tijdstip_samenstelling_bericht, true), gettype($tijdstip_samenstelling_bericht)), __LINE__);
        }
        $this->tijdstip_samenstelling_bericht = $tijdstip_samenstelling_bericht;
        return $this;
    }
    /**
     * Get betreft value
     * @return \StructType\KadasterV2GevraagdGebied
     */
    public function getBetreft()
    {
        return $this->betreft;
    }
    /**
     * Set betreft value
     * @param \StructType\KadasterV2GevraagdGebied $betreft
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setBetreft(\StructType\KadasterV2GevraagdGebied $betreft = null)
    {
        $this->betreft = $betreft;
        return $this;
    }
    /**
     * Get actualiteit_tijdstip_hypothecair value
     * @return string|null
     */
    public function getActualiteit_tijdstip_hypothecair()
    {
        return $this->actualiteit_tijdstip_hypothecair;
    }
    /**
     * Set actualiteit_tijdstip_hypothecair value
     * @param string $actualiteit_tijdstip_hypothecair
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setActualiteit_tijdstip_hypothecair($actualiteit_tijdstip_hypothecair = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteit_tijdstip_hypothecair) && !is_string($actualiteit_tijdstip_hypothecair)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteit_tijdstip_hypothecair, true), gettype($actualiteit_tijdstip_hypothecair)), __LINE__);
        }
        $this->actualiteit_tijdstip_hypothecair = $actualiteit_tijdstip_hypothecair;
        return $this;
    }
    /**
     * Get actualiteit_tijdstip_kadastraal value
     * @return string|null
     */
    public function getActualiteit_tijdstip_kadastraal()
    {
        return $this->actualiteit_tijdstip_kadastraal;
    }
    /**
     * Set actualiteit_tijdstip_kadastraal value
     * @param string $actualiteit_tijdstip_kadastraal
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setActualiteit_tijdstip_kadastraal($actualiteit_tijdstip_kadastraal = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteit_tijdstip_kadastraal) && !is_string($actualiteit_tijdstip_kadastraal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteit_tijdstip_kadastraal, true), gettype($actualiteit_tijdstip_kadastraal)), __LINE__);
        }
        $this->actualiteit_tijdstip_kadastraal = $actualiteit_tijdstip_kadastraal;
        return $this;
    }
    /**
     * Get signalering_tijdstip_beslagen value
     * @return string|null
     */
    public function getSignalering_tijdstip_beslagen()
    {
        return $this->signalering_tijdstip_beslagen;
    }
    /**
     * Set signalering_tijdstip_beslagen value
     * @param string $signalering_tijdstip_beslagen
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setSignalering_tijdstip_beslagen($signalering_tijdstip_beslagen = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_beslagen) && !is_string($signalering_tijdstip_beslagen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_beslagen, true), gettype($signalering_tijdstip_beslagen)), __LINE__);
        }
        $this->signalering_tijdstip_beslagen = $signalering_tijdstip_beslagen;
        return $this;
    }
    /**
     * Get signalering_tijdstip_hypothecair value
     * @return string|null
     */
    public function getSignalering_tijdstip_hypothecair()
    {
        return $this->signalering_tijdstip_hypothecair;
    }
    /**
     * Set signalering_tijdstip_hypothecair value
     * @param string $signalering_tijdstip_hypothecair
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setSignalering_tijdstip_hypothecair($signalering_tijdstip_hypothecair = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_hypothecair) && !is_string($signalering_tijdstip_hypothecair)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_hypothecair, true), gettype($signalering_tijdstip_hypothecair)), __LINE__);
        }
        $this->signalering_tijdstip_hypothecair = $signalering_tijdstip_hypothecair;
        return $this;
    }
    /**
     * Get signalering_tijdstip_kadastraal value
     * @return string|null
     */
    public function getSignalering_tijdstip_kadastraal()
    {
        return $this->signalering_tijdstip_kadastraal;
    }
    /**
     * Set signalering_tijdstip_kadastraal value
     * @param string $signalering_tijdstip_kadastraal
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public function setSignalering_tijdstip_kadastraal($signalering_tijdstip_kadastraal = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_kadastraal) && !is_string($signalering_tijdstip_kadastraal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_kadastraal, true), gettype($signalering_tijdstip_kadastraal)), __LINE__);
        }
        $this->signalering_tijdstip_kadastraal = $signalering_tijdstip_kadastraal;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2PostcodeTreffers
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
