<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Splitsing StructType
 * @subpackage Structs
 */
class KadasterV2Splitsing extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The vereniging_van_eigenaren
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2NietNatuurlijkPersoon
     */
    public $vereniging_van_eigenaren;
    /**
     * The gebaseerd_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $gebaseerd_op;
    /**
     * Constructor method for KadasterV2Splitsing
     * @uses KadasterV2Splitsing::setIdentificatie()
     * @uses KadasterV2Splitsing::setType()
     * @uses KadasterV2Splitsing::setVereniging_van_eigenaren()
     * @uses KadasterV2Splitsing::setGebaseerd_op()
     * @param string $identificatie
     * @param string $type
     * @param \StructType\KadasterV2NietNatuurlijkPersoon $vereniging_van_eigenaren
     * @param \ArrayType\KadasterV2StukdeelArray $gebaseerd_op
     */
    public function __construct($identificatie = null, $type = null, \StructType\KadasterV2NietNatuurlijkPersoon $vereniging_van_eigenaren = null, \ArrayType\KadasterV2StukdeelArray $gebaseerd_op = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setType($type)
            ->setVereniging_van_eigenaren($vereniging_van_eigenaren)
            ->setGebaseerd_op($gebaseerd_op);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Splitsing
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\KadasterV2Splitsing
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get vereniging_van_eigenaren value
     * @return \StructType\KadasterV2NietNatuurlijkPersoon|null
     */
    public function getVereniging_van_eigenaren()
    {
        return $this->vereniging_van_eigenaren;
    }
    /**
     * Set vereniging_van_eigenaren value
     * @param \StructType\KadasterV2NietNatuurlijkPersoon $vereniging_van_eigenaren
     * @return \StructType\KadasterV2Splitsing
     */
    public function setVereniging_van_eigenaren(\StructType\KadasterV2NietNatuurlijkPersoon $vereniging_van_eigenaren = null)
    {
        $this->vereniging_van_eigenaren = $vereniging_van_eigenaren;
        return $this;
    }
    /**
     * Get gebaseerd_op value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getGebaseerd_op()
    {
        return $this->gebaseerd_op;
    }
    /**
     * Set gebaseerd_op value
     * @param \ArrayType\KadasterV2StukdeelArray $gebaseerd_op
     * @return \StructType\KadasterV2Splitsing
     */
    public function setGebaseerd_op(\ArrayType\KadasterV2StukdeelArray $gebaseerd_op = null)
    {
        $this->gebaseerd_op = $gebaseerd_op;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2Splitsing
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
