<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Verzoek StructType
 * @subpackage Structs
 */
class KadasterV2Verzoek extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The aard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $aard;
    /**
     * The redenen_verzoek
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2RedenVerzoekArray
     */
    public $redenen_verzoek;
    /**
     * Constructor method for KadasterV2Verzoek
     * @uses KadasterV2Verzoek::setIdentificatie()
     * @uses KadasterV2Verzoek::setAard()
     * @uses KadasterV2Verzoek::setRedenen_verzoek()
     * @param string $identificatie
     * @param string $aard
     * @param \ArrayType\KadasterV2RedenVerzoekArray $redenen_verzoek
     */
    public function __construct($identificatie = null, $aard = null, \ArrayType\KadasterV2RedenVerzoekArray $redenen_verzoek = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setAard($aard)
            ->setRedenen_verzoek($redenen_verzoek);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Verzoek
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get aard value
     * @return string|null
     */
    public function getAard()
    {
        return $this->aard;
    }
    /**
     * Set aard value
     * @param string $aard
     * @return \StructType\KadasterV2Verzoek
     */
    public function setAard($aard = null)
    {
        // validation for constraint: string
        if (!is_null($aard) && !is_string($aard)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aard, true), gettype($aard)), __LINE__);
        }
        $this->aard = $aard;
        return $this;
    }
    /**
     * Get redenen_verzoek value
     * @return \ArrayType\KadasterV2RedenVerzoekArray|null
     */
    public function getRedenen_verzoek()
    {
        return $this->redenen_verzoek;
    }
    /**
     * Set redenen_verzoek value
     * @param \ArrayType\KadasterV2RedenVerzoekArray $redenen_verzoek
     * @return \StructType\KadasterV2Verzoek
     */
    public function setRedenen_verzoek(\ArrayType\KadasterV2RedenVerzoekArray $redenen_verzoek = null)
    {
        $this->redenen_verzoek = $redenen_verzoek;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2Verzoek
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
