<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2ZakelijkRecht StructType
 * @subpackage Structs
 */
class KadasterV2ZakelijkRecht extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The aard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $aard;
    /**
     * The onroerende_zaak
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2OnroerendeZaak
     */
    public $onroerende_zaak;
    /**
     * The belast_met
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2ZakelijkRechtArray
     */
    public $belast_met;
    /**
     * The bestemt_tot
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Mandeligheid
     */
    public $bestemt_tot;
    /**
     * The ontstaan_uit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Splitsing
     */
    public $ontstaan_uit;
    /**
     * The betrokken_bij
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Splitsing
     */
    public $betrokken_bij;
    /**
     * The beperkt_tot
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2TenaamstellingArray
     */
    public $beperkt_tot;
    /**
     * The indicatie_splitsing_betrokken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $indicatie_splitsing_betrokken;
    /**
     * Constructor method for KadasterV2ZakelijkRecht
     * @uses KadasterV2ZakelijkRecht::setIdentificatie()
     * @uses KadasterV2ZakelijkRecht::setAard()
     * @uses KadasterV2ZakelijkRecht::setOnroerende_zaak()
     * @uses KadasterV2ZakelijkRecht::setBelast_met()
     * @uses KadasterV2ZakelijkRecht::setBestemt_tot()
     * @uses KadasterV2ZakelijkRecht::setOntstaan_uit()
     * @uses KadasterV2ZakelijkRecht::setBetrokken_bij()
     * @uses KadasterV2ZakelijkRecht::setBeperkt_tot()
     * @uses KadasterV2ZakelijkRecht::setIndicatie_splitsing_betrokken()
     * @param string $identificatie
     * @param string $aard
     * @param \StructType\KadasterV2OnroerendeZaak $onroerende_zaak
     * @param \ArrayType\KadasterV2ZakelijkRechtArray $belast_met
     * @param \StructType\KadasterV2Mandeligheid $bestemt_tot
     * @param \StructType\KadasterV2Splitsing $ontstaan_uit
     * @param \StructType\KadasterV2Splitsing $betrokken_bij
     * @param \ArrayType\KadasterV2TenaamstellingArray $beperkt_tot
     * @param bool $indicatie_splitsing_betrokken
     */
    public function __construct($identificatie = null, $aard = null, \StructType\KadasterV2OnroerendeZaak $onroerende_zaak = null, \ArrayType\KadasterV2ZakelijkRechtArray $belast_met = null, \StructType\KadasterV2Mandeligheid $bestemt_tot = null, \StructType\KadasterV2Splitsing $ontstaan_uit = null, \StructType\KadasterV2Splitsing $betrokken_bij = null, \ArrayType\KadasterV2TenaamstellingArray $beperkt_tot = null, $indicatie_splitsing_betrokken = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setAard($aard)
            ->setOnroerende_zaak($onroerende_zaak)
            ->setBelast_met($belast_met)
            ->setBestemt_tot($bestemt_tot)
            ->setOntstaan_uit($ontstaan_uit)
            ->setBetrokken_bij($betrokken_bij)
            ->setBeperkt_tot($beperkt_tot)
            ->setIndicatie_splitsing_betrokken($indicatie_splitsing_betrokken);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get aard value
     * @return string|null
     */
    public function getAard()
    {
        return $this->aard;
    }
    /**
     * Set aard value
     * @param string $aard
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setAard($aard = null)
    {
        // validation for constraint: string
        if (!is_null($aard) && !is_string($aard)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aard, true), gettype($aard)), __LINE__);
        }
        $this->aard = $aard;
        return $this;
    }
    /**
     * Get onroerende_zaak value
     * @return \StructType\KadasterV2OnroerendeZaak|null
     */
    public function getOnroerende_zaak()
    {
        return $this->onroerende_zaak;
    }
    /**
     * Set onroerende_zaak value
     * @param \StructType\KadasterV2OnroerendeZaak $onroerende_zaak
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setOnroerende_zaak(\StructType\KadasterV2OnroerendeZaak $onroerende_zaak = null)
    {
        $this->onroerende_zaak = $onroerende_zaak;
        return $this;
    }
    /**
     * Get belast_met value
     * @return \ArrayType\KadasterV2ZakelijkRechtArray|null
     */
    public function getBelast_met()
    {
        return $this->belast_met;
    }
    /**
     * Set belast_met value
     * @param \ArrayType\KadasterV2ZakelijkRechtArray $belast_met
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setBelast_met(\ArrayType\KadasterV2ZakelijkRechtArray $belast_met = null)
    {
        $this->belast_met = $belast_met;
        return $this;
    }
    /**
     * Get bestemt_tot value
     * @return \StructType\KadasterV2Mandeligheid|null
     */
    public function getBestemt_tot()
    {
        return $this->bestemt_tot;
    }
    /**
     * Set bestemt_tot value
     * @param \StructType\KadasterV2Mandeligheid $bestemt_tot
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setBestemt_tot(\StructType\KadasterV2Mandeligheid $bestemt_tot = null)
    {
        $this->bestemt_tot = $bestemt_tot;
        return $this;
    }
    /**
     * Get ontstaan_uit value
     * @return \StructType\KadasterV2Splitsing|null
     */
    public function getOntstaan_uit()
    {
        return $this->ontstaan_uit;
    }
    /**
     * Set ontstaan_uit value
     * @param \StructType\KadasterV2Splitsing $ontstaan_uit
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setOntstaan_uit(\StructType\KadasterV2Splitsing $ontstaan_uit = null)
    {
        $this->ontstaan_uit = $ontstaan_uit;
        return $this;
    }
    /**
     * Get betrokken_bij value
     * @return \StructType\KadasterV2Splitsing|null
     */
    public function getBetrokken_bij()
    {
        return $this->betrokken_bij;
    }
    /**
     * Set betrokken_bij value
     * @param \StructType\KadasterV2Splitsing $betrokken_bij
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setBetrokken_bij(\StructType\KadasterV2Splitsing $betrokken_bij = null)
    {
        $this->betrokken_bij = $betrokken_bij;
        return $this;
    }
    /**
     * Get beperkt_tot value
     * @return \ArrayType\KadasterV2TenaamstellingArray|null
     */
    public function getBeperkt_tot()
    {
        return $this->beperkt_tot;
    }
    /**
     * Set beperkt_tot value
     * @param \ArrayType\KadasterV2TenaamstellingArray $beperkt_tot
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setBeperkt_tot(\ArrayType\KadasterV2TenaamstellingArray $beperkt_tot = null)
    {
        $this->beperkt_tot = $beperkt_tot;
        return $this;
    }
    /**
     * Get indicatie_splitsing_betrokken value
     * @return bool|null
     */
    public function getIndicatie_splitsing_betrokken()
    {
        return $this->indicatie_splitsing_betrokken;
    }
    /**
     * Set indicatie_splitsing_betrokken value
     * @param bool $indicatie_splitsing_betrokken
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public function setIndicatie_splitsing_betrokken($indicatie_splitsing_betrokken = null)
    {
        // validation for constraint: boolean
        if (!is_null($indicatie_splitsing_betrokken) && !is_bool($indicatie_splitsing_betrokken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($indicatie_splitsing_betrokken, true), gettype($indicatie_splitsing_betrokken)), __LINE__);
        }
        $this->indicatie_splitsing_betrokken = $indicatie_splitsing_betrokken;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\KadasterV2ZakelijkRecht
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
