<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OverzichtV2 StructType
 * @subpackage Structs
 */
class OverzichtV2 extends AbstractStructBase
{
    /**
     * The onroerende_zaken
     * @var \ArrayType\OverzichtOnroerendeZaakArray
     */
    public $onroerende_zaken;
    /**
     * The rechten
     * @var \ArrayType\OverzichtRechtArray
     */
    public $rechten;
    /**
     * The personen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\OverzichtPersoonV2Array
     */
    public $personen;
    /**
     * Constructor method for OverzichtV2
     * @uses OverzichtV2::setOnroerende_zaken()
     * @uses OverzichtV2::setRechten()
     * @uses OverzichtV2::setPersonen()
     * @param \ArrayType\OverzichtOnroerendeZaakArray $onroerende_zaken
     * @param \ArrayType\OverzichtRechtArray $rechten
     * @param \ArrayType\OverzichtPersoonV2Array $personen
     */
    public function __construct(\ArrayType\OverzichtOnroerendeZaakArray $onroerende_zaken = null, \ArrayType\OverzichtRechtArray $rechten = null, \ArrayType\OverzichtPersoonV2Array $personen = null)
    {
        $this
            ->setOnroerende_zaken($onroerende_zaken)
            ->setRechten($rechten)
            ->setPersonen($personen);
    }
    /**
     * Get onroerende_zaken value
     * @return \ArrayType\OverzichtOnroerendeZaakArray|null
     */
    public function getOnroerende_zaken()
    {
        return $this->onroerende_zaken;
    }
    /**
     * Set onroerende_zaken value
     * @param \ArrayType\OverzichtOnroerendeZaakArray $onroerende_zaken
     * @return \StructType\OverzichtV2
     */
    public function setOnroerende_zaken(\ArrayType\OverzichtOnroerendeZaakArray $onroerende_zaken = null)
    {
        $this->onroerende_zaken = $onroerende_zaken;
        return $this;
    }
    /**
     * Get rechten value
     * @return \ArrayType\OverzichtRechtArray|null
     */
    public function getRechten()
    {
        return $this->rechten;
    }
    /**
     * Set rechten value
     * @param \ArrayType\OverzichtRechtArray $rechten
     * @return \StructType\OverzichtV2
     */
    public function setRechten(\ArrayType\OverzichtRechtArray $rechten = null)
    {
        $this->rechten = $rechten;
        return $this;
    }
    /**
     * Get personen value
     * @return \ArrayType\OverzichtPersoonV2Array|null
     */
    public function getPersonen()
    {
        return $this->personen;
    }
    /**
     * Set personen value
     * @param \ArrayType\OverzichtPersoonV2Array $personen
     * @return \StructType\OverzichtV2
     */
    public function setPersonen(\ArrayType\OverzichtPersoonV2Array $personen = null)
    {
        $this->personen = $personen;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OverzichtV2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
