<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PerceelDetails StructType
 * @subpackage Structs
 */
class PerceelDetails extends AbstractStructBase
{
    /**
     * The perceel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadastraalPerceel
     */
    public $perceel;
    /**
     * The appartementsrecht
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VerenigingVanEigenaren
     */
    public $appartementsrecht;
    /**
     * Constructor method for PerceelDetails
     * @uses PerceelDetails::setPerceel()
     * @uses PerceelDetails::setAppartementsrecht()
     * @param \StructType\KadastraalPerceel $perceel
     * @param \StructType\VerenigingVanEigenaren $appartementsrecht
     */
    public function __construct(\StructType\KadastraalPerceel $perceel = null, \StructType\VerenigingVanEigenaren $appartementsrecht = null)
    {
        $this
            ->setPerceel($perceel)
            ->setAppartementsrecht($appartementsrecht);
    }
    /**
     * Get perceel value
     * @return \StructType\KadastraalPerceel|null
     */
    public function getPerceel()
    {
        return $this->perceel;
    }
    /**
     * Set perceel value
     * @param \StructType\KadastraalPerceel $perceel
     * @return \StructType\PerceelDetails
     */
    public function setPerceel(\StructType\KadastraalPerceel $perceel = null)
    {
        $this->perceel = $perceel;
        return $this;
    }
    /**
     * Get appartementsrecht value
     * @return \StructType\VerenigingVanEigenaren|null
     */
    public function getAppartementsrecht()
    {
        return $this->appartementsrecht;
    }
    /**
     * Set appartementsrecht value
     * @param \StructType\VerenigingVanEigenaren $appartementsrecht
     * @return \StructType\PerceelDetails
     */
    public function setAppartementsrecht(\StructType\VerenigingVanEigenaren $appartementsrecht = null)
    {
        $this->appartementsrecht = $appartementsrecht;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PerceelDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
