<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RouteLocation StructType
 * @subpackage Structs
 */
class RouteLocation extends AbstractStructBase
{
    /**
     * The address
     * @var \StructType\RouteAddress
     */
    public $address;
    /**
     * The coordinates
     * @var \StructType\RouteCoordinates
     */
    public $coordinates;
    /**
     * Constructor method for RouteLocation
     * @uses RouteLocation::setAddress()
     * @uses RouteLocation::setCoordinates()
     * @param \StructType\RouteAddress $address
     * @param \StructType\RouteCoordinates $coordinates
     */
    public function __construct(\StructType\RouteAddress $address = null, \StructType\RouteCoordinates $coordinates = null)
    {
        $this
            ->setAddress($address)
            ->setCoordinates($coordinates);
    }
    /**
     * Get address value
     * @return \StructType\RouteAddress|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param \StructType\RouteAddress $address
     * @return \StructType\RouteLocation
     */
    public function setAddress(\StructType\RouteAddress $address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get coordinates value
     * @return \StructType\RouteCoordinates|null
     */
    public function getCoordinates()
    {
        return $this->coordinates;
    }
    /**
     * Set coordinates value
     * @param \StructType\RouteCoordinates $coordinates
     * @return \StructType\RouteLocation
     */
    public function setCoordinates(\StructType\RouteCoordinates $coordinates = null)
    {
        $this->coordinates = $coordinates;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RouteLocation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
