<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SepaBankAccountIbanData StructType
 * @subpackage Structs
 */
class SepaBankAccountIbanData extends AbstractStructBase
{
    /**
     * The iban
     * @var string
     */
    public $iban;
    /**
     * The iban_details
     * @var \StructType\SepaIbanDetails
     */
    public $iban_details;
    /**
     * The bank_details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SepaBankDetails
     */
    public $bank_details;
    /**
     * The is_sepa_member
     * @var bool
     */
    public $is_sepa_member;
    /**
     * Constructor method for SepaBankAccountIbanData
     * @uses SepaBankAccountIbanData::setIban()
     * @uses SepaBankAccountIbanData::setIban_details()
     * @uses SepaBankAccountIbanData::setBank_details()
     * @uses SepaBankAccountIbanData::setIs_sepa_member()
     * @param string $iban
     * @param \StructType\SepaIbanDetails $iban_details
     * @param \StructType\SepaBankDetails $bank_details
     * @param bool $is_sepa_member
     */
    public function __construct($iban = null, \StructType\SepaIbanDetails $iban_details = null, \StructType\SepaBankDetails $bank_details = null, $is_sepa_member = null)
    {
        $this
            ->setIban($iban)
            ->setIban_details($iban_details)
            ->setBank_details($bank_details)
            ->setIs_sepa_member($is_sepa_member);
    }
    /**
     * Get iban value
     * @return string|null
     */
    public function getIban()
    {
        return $this->iban;
    }
    /**
     * Set iban value
     * @param string $iban
     * @return \StructType\SepaBankAccountIbanData
     */
    public function setIban($iban = null)
    {
        // validation for constraint: string
        if (!is_null($iban) && !is_string($iban)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iban, true), gettype($iban)), __LINE__);
        }
        $this->iban = $iban;
        return $this;
    }
    /**
     * Get iban_details value
     * @return \StructType\SepaIbanDetails|null
     */
    public function getIban_details()
    {
        return $this->iban_details;
    }
    /**
     * Set iban_details value
     * @param \StructType\SepaIbanDetails $iban_details
     * @return \StructType\SepaBankAccountIbanData
     */
    public function setIban_details(\StructType\SepaIbanDetails $iban_details = null)
    {
        $this->iban_details = $iban_details;
        return $this;
    }
    /**
     * Get bank_details value
     * @return \StructType\SepaBankDetails|null
     */
    public function getBank_details()
    {
        return $this->bank_details;
    }
    /**
     * Set bank_details value
     * @param \StructType\SepaBankDetails $bank_details
     * @return \StructType\SepaBankAccountIbanData
     */
    public function setBank_details(\StructType\SepaBankDetails $bank_details = null)
    {
        $this->bank_details = $bank_details;
        return $this;
    }
    /**
     * Get is_sepa_member value
     * @return bool|null
     */
    public function getIs_sepa_member()
    {
        return $this->is_sepa_member;
    }
    /**
     * Set is_sepa_member value
     * @param bool $is_sepa_member
     * @return \StructType\SepaBankAccountIbanData
     */
    public function setIs_sepa_member($is_sepa_member = null)
    {
        // validation for constraint: boolean
        if (!is_null($is_sepa_member) && !is_bool($is_sepa_member)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($is_sepa_member, true), gettype($is_sepa_member)), __LINE__);
        }
        $this->is_sepa_member = $is_sepa_member;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SepaBankAccountIbanData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
