<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SepaBankDetails StructType
 * @subpackage Structs
 */
class SepaBankDetails extends AbstractStructBase
{
    /**
     * The bank_code
     * @var string
     */
    public $bank_code;
    /**
     * The bank_name
     * @var string
     */
    public $bank_name;
    /**
     * The bic
     * @var string
     */
    public $bic;
    /**
     * Constructor method for SepaBankDetails
     * @uses SepaBankDetails::setBank_code()
     * @uses SepaBankDetails::setBank_name()
     * @uses SepaBankDetails::setBic()
     * @param string $bank_code
     * @param string $bank_name
     * @param string $bic
     */
    public function __construct($bank_code = null, $bank_name = null, $bic = null)
    {
        $this
            ->setBank_code($bank_code)
            ->setBank_name($bank_name)
            ->setBic($bic);
    }
    /**
     * Get bank_code value
     * @return string|null
     */
    public function getBank_code()
    {
        return $this->bank_code;
    }
    /**
     * Set bank_code value
     * @param string $bank_code
     * @return \StructType\SepaBankDetails
     */
    public function setBank_code($bank_code = null)
    {
        // validation for constraint: string
        if (!is_null($bank_code) && !is_string($bank_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bank_code, true), gettype($bank_code)), __LINE__);
        }
        $this->bank_code = $bank_code;
        return $this;
    }
    /**
     * Get bank_name value
     * @return string|null
     */
    public function getBank_name()
    {
        return $this->bank_name;
    }
    /**
     * Set bank_name value
     * @param string $bank_name
     * @return \StructType\SepaBankDetails
     */
    public function setBank_name($bank_name = null)
    {
        // validation for constraint: string
        if (!is_null($bank_name) && !is_string($bank_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bank_name, true), gettype($bank_name)), __LINE__);
        }
        $this->bank_name = $bank_name;
        return $this;
    }
    /**
     * Get bic value
     * @return string|null
     */
    public function getBic()
    {
        return $this->bic;
    }
    /**
     * Set bic value
     * @param string $bic
     * @return \StructType\SepaBankDetails
     */
    public function setBic($bic = null)
    {
        // validation for constraint: string
        if (!is_null($bic) && !is_string($bic)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bic, true), gettype($bic)), __LINE__);
        }
        $this->bic = $bic;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SepaBankDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
